ak47projectileHandler = {
	shellNum = 1,
	shells = {},
	defaultShell = {active = false}
}

ak47grenadeHandler = {
	shellNum = 1,
	shells = {},
	defaultShell = {active = false}
}

casing = {
	amount = 1,
	shells = {},
	defaultShell = {
		active = false,
		grenadeTimer = 0,
		boomTimer = 0,
		bounces = 0,
		pos = Vec(0,0,0),
		type = "casing",
		crot = 0
	}
}

function init()
	RegisterTool("vector", "Vector", "MOD/vox/vector.vox", 3)
	SetBool("game.tool.vector.enabled", true)
	SetFloat("game.tool.vector.ammo", 101)


	------INITIALISE OPTIONS MENU------
	damageoption = GetInt("savegame.mod.damage")
	if damageoption < 50 then
		damageoption = 100
		SetInt("savegame.mod.damage", 100)
	end
	slots = {}
	for i = 1,8 do
		slots[i] = {}
		for j = 1,2 do
			slots[i][j] = {"", {0, 0}, 1, 1}
		end
	end
	grabbed = {{"", {0, 0}, 1, 1}, 0, 0}
	magtable = {}

	totalmags = GetInt("savegame.mod.totalmags")

	magplace = 1
	magplaceslot = 1
	for i = 1,#slots do
		for j = 1,#slots[i] do
			if slots[i][j][2][1] == 0 and magplace < totalmags+1 then
				local w, h = 1, 1
				local mag = GetString("savegame.mod.mslot"..magplace)
				if mag == "mag0" then
					w, h = 1, 2
				elseif mag == "mag1" then
					w, h = 1, 2
				elseif mag == "mag2" then
					w, h = 2, 2
				elseif mag == "mag3" then
					w, h = 3, 2
				else
					w, h = 1, 2
				end
				placeItem({{mag, {0, 0}, w, h}, 0, 0}, magplaceslot, 2)
				magplace = magplace + 1
				magplaceslot = magplaceslot + w
			else
			end
		end
	end

	local keybinds = {{"Reload","r"},{"Check-Mag","h"},{"Fire-Mode","v"},{"Lean-Left","q"},{"Lean-Right","e"},{"Attachments","t"},{"Melee","x"},{"Side-Attachment","b"},{"Grenade-Launcher","c"},{"Inspect-Weapon","g"},{"Clear-Jam","r"}}
	for i = 1,#keybinds do
		if GetString("savegame.mod."..keybinds[i][1]) == "" then
			SetString("savegame.mod."..keybinds[i][1], keybinds[i][2])
		end
	end
	reloadKey,magcheckKey,selectfireKey,leanleftKey,leanrightKey,attachmentsKey,meleeKey,sideKey,grenadeKey,inspectKey,clearjamKey=GetString("savegame.mod.Reload"),GetString("savegame.mod.Check-Mag"),GetString("savegame.mod.Fire-Mode"),GetString("savegame.mod.Lean-Left"),GetString("savegame.mod.Lean-Right"),GetString("savegame.mod.Attachments"),GetString("savegame.mod.Melee"),GetString("savegame.mod.Side-Attachment"),GetString("savegame.mod.Grenade-Launcher"),GetString("savegame.mod.Inspect-Weapon"),GetString("savegame.mod.Clear-Jam")


	------INITIALISE WEAPON FUNCTIONS------
	damage = 0.11 * GetInt("savegame.mod.damage")/100
	if damage == 0 then
		damage = 0.11
	end
	gravity = Vec(0, -40, 0)
	velocity = 300
	maxMomentum = 2

	recoilVertical = 0.2
	recoilHorizontal = 5
	recoilWander = 4

	inside = {}
	for i = 1,100 do
		inside[i] = {0,0,0,0}
	end
	hoverindex = 0

	gunsound = LoadSound("MOD/snd/ak0.ogg")
	suppressedgunsound = LoadSound("MOD/snd/aksuppressed.ogg")
	grenadelaunchersound = LoadSound("MOD/snd/grenadelauncher.ogg")
	toprail = GetString("savegame.mod.toprail")
	muzzle = GetString("savegame.mod.muzzle")
	stock = GetString("savegame.mod.stock")
	realistic = GetBool("savegame.mod.realistic")

	--magazine system
	mslot1 = GetString("savegame.mod.mslot1")
	mslot2 = GetString("savegame.mod.mslot2")
	mslot3 = GetString("savegame.mod.mslot3")
	mslot4 = GetString("savegame.mod.mslot4")
	mslot5 = GetString("savegame.mod.mslot5")
	mslot6 = GetString("savegame.mod.mslot6")
	mslot7 = GetString("savegame.mod.mslot7")
	mslot8 = GetString("savegame.mod.mslot8")
	if totalmags == 0 then
		mslot1, mslot2 = "mag0", "mag0"
		SetString("savegame.mod.mslot1", "mag0")
		SetString("savegame.mod.mslot2", "mag0")
	totalmags = 2
	end
	magtable2 = {{mslot1,0,0},{mslot2,0,0},{mslot3,0,0},{mslot4,0,0},{mslot5,0,0},{mslot6,0,0},{mslot7,0,0},{mslot8,0,0}}
	for i=1,8 do
		local magslottype = GetString("savegame.mod.mslot"..i)
		if magslottype == "mag0" then
			magtable2[i][2] = 17
			magtable2[i][3] = 17
		elseif magslottype == "mag1" then
			magtable2[i][2] = 34
			magtable2[i][3] = 34
		elseif magslottype == "mag2" then
			magtable2[i][2] = 50
			magtable2[i][3] = 50
		elseif magslottype == "mag3" then
			magtable2[i][2] = 100
			magtable2[i][3] = 100
		end
	end
	curmagslot = 1
	nextmagslot = 1
	if realistic then
		sightadjust = -0.03
		mag = mslot1
		reloadFactor = 1
	else
		sightadjust = 0
		mag = GetString("savegame.mod.mag")
		reloadFactor = 1
	end
	grip = GetString("savegame.mod.grip")
	barrel = GetString("savegame.mod.barrel")
	side = GetString("savegame.mod.side")
	guard = GetString("savegame.mod.guard")
	cocksound = LoadSound("MOD/snd/guncock.ogg")
	cocksound2 = LoadSound("MOD/snd/guncock2.ogg")
	reloadsound = LoadSound("MOD/snd/reload.ogg")
	reloadsound2 = LoadSound("MOD/snd/reload2.ogg")
	dryfiresound = LoadSound("MOD/snd/dryfire.ogg")
	refillsound = LoadSound("MOD/snd/refill.ogg")
	selectsound = LoadSound("MOD/snd/selectorswitch.ogg")
	casingsound = LoadSound("MOD/snd/casingsound.ogg")
	interactsound1 = LoadSound("MOD/snd/interact1.ogg")
	interactsound2 = LoadSound("MOD/snd/interact2.ogg")
	uiselect = LoadSound("MOD/snd/uiselect.ogg")

	reloadTime = 2.4
	shotDelay = 0.05
	burstshots = 0
	spreadTimer = 1.25
	spreadFactor = 1.5
	accuracyFactor = 1
	bipodFactor = 1
	laserFactor = 1
	if not realistic then
		if mag == "" then
			magsize = 17
			reloadFactor = 1
		elseif mag == "mag1" then
			magsize = 33
			reloadFactor = 1.15
		elseif mag == "mag2" then
			magsize = 50
			reloadFactor = 1.35
		else
			magsize = 100
			reloadFactor = 1.5
		end
		ammo = magsize
	else
		ammo = magtable2[curmagslot][2]
	end
	barrellength = 0
	guardlength = 0
	guardheight = 0
	barrelFactorx = 0.8
	barrelFactory = 1.5
	barrelFactordamage = 1.25
	grenadelauncherammo = 1
	mags = 2
	reloading = false
	ironsight = false
	ADSx = 0
	ADSy = 0
	ADSz = 0
	ADSrot = 0
	ADSfov = 0
	RELx = 0
	RELy = 0
	RELz = 0
	RELrotx = 0
	RELroty = 0
	RELrotz = 0
	SELx = 0
	SELy = 0
	SELz = 0
	SELrotx = 0
	SELroty = 0
	SELrotz = 0
	INSx = 0
	INSy = 0
	INSz = 0
	INSrotx = 0
	INSroty = 0
	INSrotz = 0
	RECx = 0
	RECy = 0
	RECz = 0
	RECrotx = 0
	RECroty = 0
	RECrotz = 0
	sideattachment = false
	range = 0
	grenadelauncher = false
	unlimitedammo = GetBool("savegame.mod.unlimitedammo")
	spentcasingsoption = GetBool("savegame.mod.spentcasingsoption")

	for i=1, ammo do
		ak47projectileHandler.shells[i] = deepcopy(ak47projectileHandler.defaultShell)
	end
	for i=1, 10 do
		ak47grenadeHandler.shells[i] = deepcopy(ak47projectileHandler.defaultShell)
	end

	shootTimer = 0
	reloadTimer = 0
	recoilTimer = 0
	recoilAngle = 0
	recoilFactor = 0
	stockFactor = 0
	muzzleFactor = 0
	muzzlelength = 0
	gripfactorx = 0
	gripfactory = 0
	recoilMax = 0
	rnd1, rnd2, rnd3, rnd4, rnd5, rnd6 = 0, 0, 0, 0, 0, 0
	lightTimer = 0
	clickedmag = false
	animationTimers = {0, 0, 0, 0, 0}
	fovTimer = 0
	animation1Timer = 0
	optionsrotx = -50
	optionsroty = 0
	optionszoom = 0
	optionsx = 0

	magoutTimer = 0
	maginTimer = 0
	meleeTimer = 0
	magcheckTimer = 0
	selecttextTimer = 0
	cocksoundplaying = false
	selectsoundplaying = false
	selectattachments = false
	selectmag = false
	jammed = false
	jamclearTimer = 0
	selectattachmentsTimer = 0
	inspectTimer = 0
	heldrTimer = 0
	scopeTimer = 0

	e = false
	q = false
	selectfire = 0
	selectfire0 = 3
	selectfireTimer = 0
	selectfireText = "Safe"

	sin1 = 0
	cos1 = 1
	sin2 = 0
	cos2 = 1
	swayx = 0
	swayy = 0

	despawnTime = 20
	casingGravity = Vec(0, -150, 0)
	throwVel = 50
end

function deepcopy(orig)
    local orig_type = type(orig)
    local copy
    if orig_type == 'table' then
        copy = {}
        for orig_key, orig_value in next, orig, nil do
            copy[deepcopy(orig_key)] = deepcopy(orig_value)
        end
        setmetatable(copy, deepcopy(getmetatable(orig)))
    else
        copy = orig
    end
    return copy
end

function GetAimPos()
	local ct = GetCameraTransform()
	local forwardPos = TransformToParentPoint(ct, Vec(0, 0, -100))
    local direction = VecSub(forwardPos, ct.pos)
    local distance = VecLength(direction)
	local direction = VecNormalize(direction)
	local hit, hitDistance = QueryRaycast(ct.pos, direction, distance)
	if hit then
		forwardPos = TransformToParentPoint(ct, Vec(0, 0, -hitDistance))
		distance = hitDistance
	end
	return forwardPos, hit, distance
end

function Shoot()
	if shootTimer > 0 or ammo == 0 then
		return
	end

	aimpos, hit, distance = GetAimPos()

	local gt = GetBodyTransform(GetToolBody())
	local fwdpos = TransformToParentPoint(gt, Vec(0.275, -0.6, -100))
	local gunpos = TransformToParentPoint(gt, Vec(0.275, -0.6, -1.2))
	dir = VecNormalize(VecSub(fwdpos, gunpos))

	local maxSpread = InputDown("ctrl") and 2 or 3
	if ironsight then maxSpread = maxSpread / 3 end
	local factor = stockFactor*laserFactor*muzzleFactor*gripfactorx*barrelFactorx
	rnd1, rnd2, rnd3, rnd4, rnd5, rnd6 = rnd1+(math.random()-0.5)*factor*recoilWander, rnd2+(math.random()-0.5)*factor*recoilWander, rnd3+(math.random()-0.5)*factor*recoilWander/4, (math.random()-0.5)*factor*recoilHorizontal, (math.random()-0.5)*factor*recoilHorizontal, (math.random()-0.5)*factor*recoilHorizontal/4

	if not ironsight then
		accuracyFactor = 12
	end
	if recoilAngle < recoilMax then
		recoilAngle = recoilAngle + recoilFactor*muzzleFactor*gripfactory*barrelFactory
	end

	ak47projectileHandler.shells[ak47projectileHandler.shellNum] = deepcopy(ak47projectileHandler.defaultShell)
	loadedShell = ak47projectileHandler.shells[ak47projectileHandler.shellNum] 
	loadedShell.active = true
	loadedShell.pos = gunpos
	loadedShell.momentum = maxMomentum
	if muzzle == "muzzle1" then
		loadedShell.predictedBulletVelocity = VecScale(dir, velocity*barrelFactory)
	else
		loadedShell.predictedBulletVelocity = VecScale(dir, velocity*0.8*barrelFactory)
	end GetTimeStep()
	ak47projectileHandler.shellNum = (ak47projectileHandler.shellNum%#ak47projectileHandler.shells) + 1

	loadedShell.predictedBulletVelocity = VecAdd(loadedShell.predictedBulletVelocity, Vec((math.random()-0.5)*accuracyFactor*2, (math.random()-0.5)*accuracyFactor*2, (math.random()-0.5)*accuracyFactor*2))

	local barrelend = barrellength + muzzlelength
	SpawnParticle("smoke", TransformToParentPoint(GetBodyTransform(GetToolBody()), Vec(0.25, -0.55, -2.4-barrelend*4/3)), VecAdd(VecScale(dir, 2), GetPlayerVelocity()), 0.2, 0.3)
	ParticleType("plain")
	ParticleTile(5)
	ParticleColor(1, 0.6, 0.4, 1, 0.3, 0.2)
	ParticleRadius(0.2)
	ParticleEmissive(5, 1)
	SpawnParticle(TransformToParentPoint(GetBodyTransform(GetToolBody()), Vec(0.25, -0.55, -2.4-barrelend*4/3)), VecAdd(VecScale(dir, 4), GetPlayerVelocity()), shotDelay/2, 0.3)
	if muzzle == "muzzle1" then
		PlaySound(suppressedgunsound, GetPlayerTransform().pos, 1, false)
	elseif muzzle == "muzzle2" then
		PlaySound(gunsound, GetPlayerTransform().pos, 0.9, false)
	else
		PlaySound(gunsound, GetPlayerTransform().pos, 0.75, false)
	end

	if not unlimitedammo then
		ammo = ammo - 1
		if realistic then
			magtable2[curmagslot][2] = ammo
		end
	end
	if ammo == 0 then
		SpawnParticle("fire", TransformToParentPoint(GetBodyTransform(GetToolBody()), Vec(0.35, -0.55, -1.1)), Vec(0, 0, 0), 0.4, 1)
	end

	if selectfire == 3 or selectfire == 2 then
		shootTimer = shotDelay
		recoilTimer = shotDelay
		lightTimer = shotDelay/2
		spreadTimer = spreadTimer + 1.25
		burstshots = burstshots+1
	else
		shootTimer = 0
		recoilTimer = shotDelay
		lightTimer = shotDelay/2
		spreadTimer = spreadTimer + 1.25
	end

	if spentcasingsoption then
		SpentCasing()
	end

	local jamrate = 1/400
	if realistic and math.random() < jamrate and ammo > 0 then
		jammed = true
		PlaySound(dryfiresound, GetPlayerTransform().pos, 1, false)
	end
	
	local pvel = GetPlayerVelocity()
	local prot = QuatToEuler(GetPlayerTransform(true).rot)
	local ppos = GetPlayerTransform().pos
	local camrot = QuatToEuler(GetPlayerCameraTransform().rot)
	local ppos2 = Transform()
	ppos2.rot = QuatEuler(prot[1], camrot[2], camrot[3])
	ppos2.rot = QuatRotateQuat(ppos2.rot, QuatEuler(recoilFactor*muzzleFactor*gripfactory*barrelFactory*3-rnd4/4, -rnd5/4, -rnd6/4))
	ppos2.pos = ppos
	SetPlayerTransform(ppos2, true)
	SetPlayerVelocity(pvel)
end
function QuatToEuler(quat)
	local euler={}
	local x,y,z=GetQuatEuler(quat)
	euler[1]=x
	euler[2]=y
	euler[3]=z
	return euler
end

function ShootGrenade()
	if shootTimer > 0 or grenadelauncherammo == 0 then
		return
	end

	aimpos, hit, distance = GetAimPos()

	local gt = GetBodyTransform(GetToolBody())
	local fwdpos = TransformToParentPoint(gt, Vec(0.4, -1, -100))
	local gunpos = TransformToParentPoint(gt, Vec(0.4, -1, -2.2))
	dir = VecSub(fwdpos, gunpos)

	if recoilAngle < recoilMax then
		recoilAngle = recoilAngle + recoilFactor*muzzleFactor*gripfactory*barrelFactory
	end

	ak47grenadeHandler.shells[ak47grenadeHandler.shellNum] = deepcopy(ak47grenadeHandler.defaultShell)
	loadedShell = ak47grenadeHandler.shells[ak47grenadeHandler.shellNum]
	loadedShell.active = true
	loadedShell.pos = gunpos
	loadedShell.predictedBulletVelocity = VecScale(dir, 0.35*(300/distance))
	ak47grenadeHandler.shellNum = (ak47grenadeHandler.shellNum%#ak47grenadeHandler.shells) + 1

	SpawnParticle("fire", gunpos, Vec(0, 1.0+math.random(1,10)*0.1, 0), 0.3, 0.1)
	PlaySound(grenadelaunchersound, GetPlayerTransform().pos, 0.75, false)

	if not unlimitedammo then
		grenadelauncherammo = grenadelauncherammo - 1
	end
end

function ProjectileOperations(projectile)
	projectile.predictedBulletVelocity = VecAdd(projectile.predictedBulletVelocity, (VecScale(gravity, GetTimeStep())))
	local point2 = VecAdd(projectile.pos, VecScale(projectile.predictedBulletVelocity, GetTimeStep()))
	local dir = VecNormalize(VecSub(point2, projectile.pos))
	local hit, dist, normal, shape = QueryRaycast(projectile.pos, dir, VecLength(VecSub(point2, projectile.pos)))
	if hit then
		hitPos = VecAdd(projectile.pos, VecScale(VecNormalize(VecSub(point2, projectile.pos)), dist))
		point2 = hitPos
		DrawLine(projectile.pos, point2)
		local mat, r, g, b, a = GetShapeMaterialAtPosition(shape, hitPos)

		if mat == "metal" or mat == "heavymetal" or mat == "hardmetal" then
			bounceangle = 20
		else
			bounceangle = 10
		end

		local hitangle = math.acos(VecDot(projectile.predictedBulletVelocity, normal)/VecLength(projectile.predictedBulletVelocity))*57.3-90
		if hitangle < bounceangle and math.random(0, 100)/100 > (hitangle/bounceangle)^2 then
			PlaySound(bouncesound, projectile.pos, 1, false)
			local dot = VecDot(normal, projectile.predictedBulletVelocity)
			projectile.predictedBulletVelocity = VecSub(projectile.predictedBulletVelocity, VecScale(normal, dot*(1+math.random(1,10)/10)))
		else
			ApplyBodyImpulse(GetShapeBody(shape), hitPos, VecScale(projectile.predictedBulletVelocity, 0.15))

			if mat == "glass" and math.random() > 0.65 then
				MakeHole(hitPos, 0.75)
				projectile.momentum = projectile.momentum - 0.2
			elseif mat == "metal" or mat == "heavymetal" or mat == "hardmetal" then
				SpawnParticle("smoke", hitPos, Vec(0, 1.0+math.random(1,10)*0.1, 0), damage, 1)
				ParticleReset()
				ParticleType("plain")
				ParticleTile(6)
				ParticleSticky(0, 0)
				ParticleRadius(0.01, 0.01)
				ParticleAlpha(1, 0)
				ParticleEmissive(10, 10)
				ParticleColor(1, 0.75, 0.25, 1, 0.25, 0.25)
				ParticleGravity(-10, -10)
				for i = 1, math.random(10, 10*maxMomentum) do
					SpawnParticle(hitPos, Vec((math.random(-100,100)/100)*5,(math.random(-100,100)/100)*5, (math.random(-100,100)/100)*5), math.random(10,25)/20)
				end
				PointLight(hitPos, 1, 0.75, 0.25, 0.25)
				if mat == "hardmetal" then
					projectile.momentum = projectile.momentum - 2
				else
					projectile.momentum = projectile.momentum - 1
				end
			else
				ParticleReset()
				ParticleType("plain")
				ParticleTile(6)
				ParticleSticky(0, 0)
				ParticleRadius(0.05, 0.05)
				ParticleAlpha(a, 0)
				ParticleEmissive(0, 0)
				ParticleColor(r, g, b, r, g, b)
				ParticleGravity(-10, -10)
				for i = 1, math.random(10, 10*maxMomentum) do
					SpawnParticle(hitPos, Vec((math.random(-100,100)/100)*5,(math.random(-100,100)/100)*5, (math.random(-100,100)/100)*5), math.random(10,25)/20)
					if mat == "dirt" then
						ParticleTile(1)
						ParticleRadius(0.5, 0.1)
						SpawnParticle(hitPos, Vec((math.random(-100,100)/100),(math.random(-100,100)/100)*5, (math.random(-100,100)/100)), math.random(10,25)/20)
					end
				end
				projectile.momentum = projectile.momentum - 0.5
			end

			local factor = barrelFactordamage

			if projectile.momentum > 0 then
				MakeHole(hitPos, damage*factor, damage*0.85*factor, damage*0.7*factor)
			end
		end
	else
		point2 = VecAdd(projectile.pos, VecScale(projectile.predictedBulletVelocity, GetTimeStep()))
		DrawLine(projectile.pos, point2)
	end
	
	if projectile.momentum < 0.1 or projectile.pos[2] < 0 then
		projectile.active = false
	end

	projectile.pos = point2
end

function GrenadeOperations(projectile)
	projectile.predictedBulletVelocity = VecAdd(projectile.predictedBulletVelocity, (VecScale(gravity, GetTimeStep())))
	local point2 = VecAdd(projectile.pos, VecScale(projectile.predictedBulletVelocity, GetTimeStep()))
	local dir = VecNormalize(VecSub(point2, projectile.pos))
	local hit, dist, normal, shape = QueryRaycast(projectile.pos, dir, VecLength(VecSub(point2, projectile.pos)))
	if hit then
		hitPos = VecAdd(projectile.pos, VecScale(VecNormalize(VecSub(point2, projectile.pos)), dist))
		Explosion(hitPos, 1)
	else
		point2 = VecAdd(projectile.pos, VecScale(projectile.predictedBulletVelocity, GetTimeStep()))
		DrawLine(projectile.pos, point2)
	end
	
	if hit then
		projectile.active = false
	end

	projectile.pos = point2
end

function Bouncing(projectile)
	projectile.predictedBulletVelocity = VecAdd(projectile.predictedBulletVelocity, (VecScale(projectile.gravity, GetTimeStep()/4)))
	local point2 = VecAdd(projectile.pos, VecScale(projectile.predictedBulletVelocity, GetTimeStep()/4))
	local dir = VecNormalize(VecSub(point2, projectile.pos))
	local distance = VecLength(VecSub(point2, projectile.pos))
	local hit, dist, normal = QueryRaycast(projectile.pos, dir, distance)
	if hit then
		PlaySound(casingsound, GetPlayerTransform().pos, 0.5/(projectile.bounces+1), false)
		if projectile.bounces == 6 then
			projectile.gravity = Vec(0, 0, 0)
			projectile.predictedBulletVelocity = Vec(0, 0, 0)
		else
			local dot = VecDot(normal, projectile.predictedBulletVelocity)
			projectile.predictedBulletVelocity = VecSub(projectile.predictedBulletVelocity, VecScale(normal, dot*1.4))
			projectile.bounces = projectile.bounces + 1
		end
	else
		projectile.pos = point2
	end
end

function Reload()
	if reloading then
		return
	end
	reloading = true
	if grenadelauncher then
		if grenadelauncherammo == 0 then
			reloadTimer = reloadTime - 1
		end
	else
		if ammo == 0 then
			reloadTimer = reloadTime
		else
			reloadTimer = reloadTime - 1
		end
		if realistic then
			if ammo == 0 then
				magtable2[curmagslot][2] = ammo
			else
				magtable2[curmagslot][2] = ammo - 1
			end
			curmagslot = nextmagslot
		end
		magoutTimer = 0.6
		PlaySound(reloadsound, GetPlayerTransform().pos, 0.5, false)
	end
end

function SelectFire()
	if selectfire == 0 or selectfire == 3 then
		PlaySound(selectsound, GetPlayerTransform().pos, 0.85)
	end
	selectfire = selectfire + 1
	if selectfire > 3 then
		selectfire = 0
	end
	if selectfire == 1 then
		selectfireTimer = 0.5
	else
		selectfireTimer = 1
	end

	selectfire0 = selectfire0 + 1
	if selectfire0 > 3 then
		selectfire0 = 0
	end
	selectsoundplaying = false
end

function Animate(transVariable, bool, animationTime, animateTransform, index)
	local dt = GetTimeStep()

	local animationTimer = animationTimers[index]

	if bool and animationTimer < animationTime then
		animationTimer = animationTimer*1.1 + dt
		if animationTimer >= animationTime then
			animationTimer = animationTime
		end
	elseif bool and animationTimer > animationTime then
		animationTimer = animationTimer*0.9 - dt/20
	elseif not bool and fovTimer > 0 then
		animationTimer = animationTimer*0.9 - dt/20
		if animationTimer < 0 then
			animationTimer = 0
		end
	end

	local x1 = animateTransform.pos[1]
	local y1 = animateTransform.pos[2]
	local z1 = animateTransform.pos[3]

	local rx1 = animateTransform.rot[1]
	local ry1 = animateTransform.rot[2]
	local rz1 = animateTransform.rot[3]

	local at = animationTimer / animationTime

	transVariable.pos = VecAdd(transVariable.pos, Vec(x1*at, y1*at, z1*at))
	transVariable.rot = QuatRotateQuat(transVariable.rot, QuatEuler(rx1*at, ry1*at, rz1*at))

	animationTimers[index] = animationTimer

	return transVariable
end

function SpentCasing()
	local ct = GetBodyTransform(GetToolBody())
	local fwdpos = TransformToParentPoint(ct, Vec(0.7+math.random(1,10)*0.01, -0.35+math.random(1,10)*0.01, -1.15+math.random(1,10)*0.01))
	local gunpos = TransformToParentPoint(ct, Vec(0.4, -0.5, -1.2))
	local direction = VecSub(fwdpos, gunpos)
	swingTimer = 0.125

	casing.shells[casing.amount] = deepcopy(casing.defaultShell)
	spentcasing = casing.shells[casing.amount];
	spentcasing.active = true
	spentcasing.type = casing

	spentcasing.sprite = LoadSprite("MOD/img/casing.png")

	spentcasing.pos = gunpos
	spentcasing.predictedBulletVelocity = VecScale(direction, throwVel)
	spentcasing.despawnTimer = despawnTime
	spentcasing.gravity = casingGravity

	casing.shells[casing.amount][6] = math.random(1,360)
	casing.amount = casing.amount + 1
end

function drawHint(info)
	if info[5] < 0.1 then
		return
	end
	UiPush()
		UiTranslate(info[1],info[2])
		local maxW=0
		UiFont("bold.ttf",20)
		maxW=UiGetTextSize(info[8][1])
		local row=1
		UiFont("regular.ttf",15)
		for i=2,#info[8] do
			maxW=math.max(UiGetTextSize(info[8][i]),maxW)
			row=i
		end
		UiTranslate(-((info[3]+maxW+40)/2+10)*info[6],-((info[4]+(10+row*20)+12)/2+10)*info[7])
		UiColor(0,0,0,info[5]*.5)
		UiTranslate(-15, -35)
		UiImageBox("ui/common/box-solid-6.png",40+maxW,20+row*20,6,6)
		UiColor(1,1,1,info[5])
		UiImageBox("ui/common/box-outline-6.png",40+maxW,20+row*20,6,6)
		UiTranslate(15, 35)
		UiTranslate(0,(row-1)*-10)
		UiFont("bold.ttf",20)
		UiText(info[8][1])
		UiFont("regular.ttf",15)
		for i=2,row do
			UiTranslate(0,20)
			UiText(info[8][i])
		end
	UiPop()
end

function AttachmentButton(itemType,itemID,wantHint,location,Description,W,H)
	local clicked=false
	UiPush()
		local item=GetString("savegame.mod."..itemType)
		if item==itemID then
			UiColor(.5,1,.5,.5)
		else
			UiColor(0,0,0,.5)
		end
		local w,h=UiGetImageSize("MOD/icon/"..itemID..".png")
		local ww=W or w+12
		local wh=H or h+12
		UiImageBox("ui/common/box-solid-6.png",ww,wh,6,6)
		UiColor(1,1,1)
		UiImageBox("ui/common/box-outline-6.png",ww,wh,6,6)
		if UiImageButton("MOD/icon/"..itemID..".png")then
			clicked=true
			PlaySound(uiselect, GetPlayerTransform().pos, 1)
			if item == itemID then
				SetString("savegame.mod."..itemType, "")
			else
				SetString("savegame.mod."..itemType, itemID)
			end
		end
		if wantHint then
			hoverindex=hoverindex+1
			local hover,x,y=hovering(ww,wh,hoverindex)
			if hover > 0 then
				hint=true
				info={location[1],location[2],ww,wh,hover,x,y,Description}
			else
				hint=hint or false
			end
		end
	UiPop()
	return clicked,ww,wh
end

function AttachmentGroup(itemType,itemID,location,Description,order,W,H)
	local clicked=false
	UiPush()
		UiAlign("center middle")
		local itemSelected = GetString("savegame.mod."..itemID)
		if itemSelected == "" then
			itemSelected = "none"
		end
		local w,h=UiGetImageSize("MOD/icon/"..itemSelected..".png")
		local ww=W or w+12
		local wh=H or h+12

		x,y,dist=UiWorldToPixel(location)
		UiTranslate(x,y)
		if dist<0 then UiPop() return end
		
		local item=GetString("savegame.mod."..itemType)
		if item==itemID then
			UiColor(.5,1,.5,.5)
		else
			UiColor(0,0,0,.5)
		end
		UiImageBox("ui/common/box-solid-shadow-50.png",120,120,6,6)

		local ppos=GetPlayerTransform(GetToolBody())
		order = 1-order
		location2 = TransformToParentPoint(ppos, Vec(optionsx*3+math.sin(order*math.pi*1.5-math.pi*1.66)*3, 1-math.cos(order*math.pi*1.5-math.pi*1.66)*2, -5))
		DebugLine(location, location2, 1, 1, 1, 1)
		x2,y2=UiWorldToPixel(location2)
		UiTranslate(x2,y2)
		UiImageBox("ui/common/box-solid-6.png",ww,wh,6,6)
		UiColor(1,1,1)
		UiImageBox("ui/common/box-outline-6.png",ww,wh,6,6)
		if UiImageButton("MOD/icon/"..itemSelected..".png",ww,wh)then
			clicked=true
			PlaySound(uiselect, GetPlayerTransform().pos, 1)
			if item == itemID then
				SetString("savegame.mod."..itemType, "")
			else
				SetString("savegame.mod."..itemType, itemID)
			end
		end
	UiPop()
	return location2
end

function KeybindButton(keybind)
	local clicked=false
	UiPush()
		if keybind==GetString("savegame.mod.currentkey") then
			UiColor(.5,1,.5,.5)
			keys = {"q","w","e","r","t","y","u","i","o","p","a","s","d","f","g","h","j","k","l","z","x","c","v","b","n","m","[","]",";",",","."}
			for i = 1,#keys do
				if InputPressed(keys[i]) then
					SetString("savegame.mod."..keybind, keys[i])
					SetString("savegame.mod.currentkey", "")
				end
			end
		else
			UiColor(0,0,0,.5)
		end
		local w,h=UiGetTextSize(keybind..": a")
		local ww=W or w+12
		local wh=40
		UiImageBox("ui/common/box-solid-6.png",ww,wh,6,6)
		UiColor(1,1,1)
		UiImageBox("ui/common/box-outline-6.png",ww,wh,6,6)
		if UiTextButton(keybind..": "..string.upper(GetString("savegame.mod."..keybind)))then
			clicked=true
			PlaySound(uiselect, GetPlayerTransform().pos, 1)
			SetString("savegame.mod.currentkey", keybind)
		end
	UiPop()
	return clicked,ww,wh
end

function MagButton(itemType,itemID,wantHint,location,Description,W,H)
	local clicked=false
	UiPush()
		local item=itemType
		if item==itemID then
			UiColor(.5,1,.5,.5)
		else
			UiColor(0,0,0,.5)
		end
		local curmagslot0=GetString("savegame.mod.mslot"..itemID)
		local w,h=UiGetImageSize("MOD/icon/"..curmagslot0..".png")
		local ww=W or w+12
		local wh=H or h+12
		UiImageBox("ui/common/box-solid-6.png",ww,wh,6,6)
		UiColor(1,1,1)
		UiImageBox("ui/common/box-outline-6.png",ww,wh,6,6)
		if UiImageButton("MOD/icon/"..curmagslot0..".png")then
			clicked=true
			PlaySound(uiselect, GetPlayerTransform().pos, 1)
			nextmagslot = itemID
		end
		if wantHint then
			hoverindex=hoverindex+1
			local hover,x,y=hovering(ww,wh,hoverindex)
			if hover > 0 then
				hint=true
				info={location[1],location[2],ww,wh,hover,x,y,Description}
			else
				hint=hint or false
			end
		end
	UiPop()
	return clicked,ww,wh
end

function placeItem(grabinfo, i, j)
	local item, parent, w, h, origx, origy = grabinfo[1][1], grabinfo[1][2], grabinfo[1][3], grabinfo[1][4], grabinfo[2], grabinfo[3]
	local collision = false

	if i+w-1 > #slots or j-h+1 <= 0 then
		if origx>=w and origy>=h then
			slots[origx][origy] = {item, {origx, origy}, w, h}
		end
		return
	end

	for a = 1, w do
		for b = 1, h do
			if (origx+a-1)>0 and (origy-b+1)>0 then
				slots[origx+a-1][origy-b+1][2] = {0, 0}
				slots[origx+a-1][origy-b+1][3], slots[origx+a-1][origy-b+1][4]= 1, 1
			end
		end
	end

	for a = 1, w do
		for b = 1, h do
			if slots[i+a-1][j-b+1][2][1] ~= 0 then collision = true end
		end
	end
	if not collision then
		slots[i][j] = {item, {i, j}, w, h}
		for a = 1, w do
			for b = 1, h do
				slots[i+a-1][j-b+1][2][1] = {i, j}

			end
		end
	elseif collision and origx == 0 then
		return
	else
		slots[origx][origy] = {item, {origx, origy}, w, h}
		for a = 1, w do
			for b = 1, h do
				slots[origx+a-1][origy-b+1][2][1] = {origx, origy}
			end
		end
	end
end

function clearItem(grabinfo)
	local item, parent, w, h, origx, origy = grabinfo[1][1], grabinfo[1][2], grabinfo[1][3], grabinfo[1][4], grabinfo[2], grabinfo[3]

	for a = 1, w do
		for b = 1, h do
			if (origx+a-1)>0 and (origy-b+1)>0 then
				slots[origx+a-1][origy-b+1][2] = {0, 0}
				slots[origx+a-1][origy-b+1][3], slots[origx+a-1][origy-b+1][4]= 1, 1
			end
		end
	end
end

function MagButton2(mag, w, h)
	UiPush()
		UiImageBox("ui/common/box-solid-6.png", 60*w, 60*h, 6, 6)
		UiColor(1,1,1)
		UiImageBox("ui/common/box-outline-6.png", 60*w, 60*h, 6, 6)
		UiImageBox("MOD/icon/"..mag..".png", 60*w, 60*h)
		UiTranslate(30*(w-1), 30*(h-2))
		local inside2 = UiIsMouseInRect(60*w-1, 60*h-1)
		UiTranslate(-30*(w-1), -30*(h-2))
		if inside2 and InputPressed("lmb") then
			grabbed = {{mag, {0, 0}, w, h}, 0, 0}
		end
	UiPop()
end

function hovering(w,h,index)
	local dt=GetTimeStep()
	if UiIsMouseInRect(w,h)then
		local x,y=UiGetMousePos()
		x=x/(w/2)
		y=y/(h/2)
		local scale=math.max(math.abs(x),math.abs(y))
		if scale ~= 0 then
			inside[index][3]=(x/scale)*.1+inside[index][3]*.9
			inside[index][4]=(y/scale)*.1+inside[index][4]*.9
		end

		if inside[index][1]>=1 then
			inside[index][2]=math.min(1,inside[index][2]+dt*2)
		else
			inside[index][1]=math.min(1,inside[index][1]+dt*2)
		end
	else
		inside[index][1]=math.max(0,inside[index][1]-dt*4)
		inside[index][2]=math.max(0,inside[index][2]-dt*4)
	end
	return inside[index][2],inside[index][3],inside[index][4]
end

function Laser(active)
		local gt = GetBodyTransform(GetToolBody())
		local gunpos = TransformToParentPoint(gt, Vec(0.275, -0.5, -1.9))
		local fwdpos = TransformToParentVec(gt, Vec(0, 0, -1))
		local hit, dist = QueryRaycast(gunpos, fwdpos, 500, 0, true)
		local hitpoint = VecAdd(gunpos, VecScale(fwdpos, dist))

		if active then
			SetShapeEmissiveScale(side1, 1)
			PointLight(hitpoint, 0, 1, 0, 0.2)
			DrawLine(gunpos, hitpoint, 0, 1, 0, 0.2)
			laserFactor = 0.9
		else
			SetShapeEmissiveScale(side1, 0)
			laserFactor = 1
		end
end
function Flashlight(active)
		local gt = GetBodyTransform(GetToolBody())
		local gunpos = TransformToParentPoint(gt, Vec(0.275, -0.5, -1.9))
		local fwdpos = TransformToParentVec(gt, Vec(0, 0, -1))
		local hit, dist = QueryRaycast(gunpos, fwdpos, 500, 0, true)

		if active then
			SetShapeEmissiveScale(side2, 1)
			PointLight(gunpos, 0.5, 0.5, 0.5, 0.1)
			for i = 1, dist*5 do
				local hitpoint = VecAdd(gunpos, VecScale(fwdpos, i/5))
				local b = 0.1
				PointLight(hitpoint, b/i^2.2, b/i^2.2, b/i^2.2, 2*i^2)
			end
		else
			SetShapeEmissiveScale(side2, 0)
		end
end
function Rangefinder(active)
		local gt = GetBodyTransform(GetToolBody())
		local gunpos = TransformToParentPoint(gt, Vec(0.175, -0.625, -1.9))
		local fwdpos = TransformToParentVec(gt, Vec(0, 0, -1))
		local hit, dist = QueryRaycast(gunpos, fwdpos, 500, 0, true)

		if active then
			range = dist
		else
			range = 0
		end
end

function ADS(bool, fov, fovTime, x, y, z, rot)
	local toolTrans = TransformToLocalTransform(GetCameraTransform(), GetBodyTransform(GetToolBody()))
	local toolx = toolTrans.pos[1]
	local tooly = toolTrans.pos[2]
	local toolz = toolTrans.pos[3]
	local rotx, roty, rotz = GetQuatEuler(toolTrans.rot)
	local toolrot = rotz

	local dt = GetTimeStep()*8/reloadFactor
	if grip == grip2 then
		dt = dt*1.25
	end

	if bool then
		if x > ADSx then 
			ADSx = ADSx + dt*math.abs((x-ADSx))
		elseif x < ADSx then
			ADSx = ADSx - dt*math.abs((x-ADSx))
		end
		if y > ADSy then 
			ADSy = ADSy + dt*math.abs((y-ADSy))
		elseif y < ADSy then
			ADSy = ADSy - dt*math.abs((y-ADSy))
		end
		if z > ADSz then 
			ADSz = ADSz + dt*math.abs((z-ADSz))
		elseif z < ADSz then
			ADSz = ADSz - dt*math.abs((z-ADSz))
		end
		if rot > ADSrot then 
			ADSrot = ADSrot + dt*math.abs((rot-ADSrot))
		elseif rot < ADSrot then
			ADSrot = ADSrot - dt*math.abs((rot-ADSrot))
		end
		if fov > ADSfov then 
			ADSfov = ADSfov + dt*math.abs((fov-ADSfov))
		elseif fov < ADSfov then
			ADSfov = ADSfov - dt*math.abs((fov-ADSfov))
		end
	end

	if not bool then
		if ADSx > 0.1 then 
			ADSx = ADSx - dt*math.abs((ADSx-0.1))
		elseif ADSx < 0.1 then
			ADSx = ADSx + dt*math.abs((ADSx-0.1))
		end
		if ADSy > 0.1 then 
			ADSy = ADSy - dt*math.abs((ADSy-0.1))
		elseif ADSy < 0.1 then
			ADSy = ADSy + dt*math.abs((ADSy-0.1))
		end
		if ADSz > -0.1 then 
			ADSz = ADSz - dt*math.abs((ADSz+0.1))
		elseif ADSz < -0.1 then
			ADSz = ADSz + dt*math.abs((ADSz+0.1))
		end
		if ADSrot > 0 then 
			ADSrot = ADSrot - dt*math.abs((ADSrot-0))
		elseif ADSrot < 0 then
			ADSrot = ADSrot + dt*math.abs((ADSrot-0))
		end
		if ADSfov > 0.25 then 
			ADSfov = ADSfov - dt*math.abs((ADSfov-0))
		elseif ADSz < 0.25 then
			ADSfov = ADSfov + dt*math.abs((ADSfov-0))
		end
	end

	local ADSvec = Vec(ADSx, ADSy, ADSz)

	local offset = Transform(Vec(0, 0, 0), QuatEuler(0, 0, ADSrot))
	offset.pos = VecAdd(offset.pos, ADSvec)
	SetCameraFov(GetInt("options.gfx.fov")-ADSfov+recoilTimer*5)

	return offset
end

function REL(bool, x, y, z, rotx, roty, rotz)
	local dt = GetTimeStep()*2/reloadFactor

	if bool then
		if x > RELx then 
			RELx = RELx + dt*math.abs((x-RELx))
		elseif x < RELx then
			RELx = RELx - dt*math.abs((x-RELx))
		end
		if y > RELy then 
			RELy = RELy + dt*math.abs((y-RELy))
		elseif y < RELy then
			RELy = RELy - dt*math.abs((y-RELy))
		end
		if z > RELz then 
			RELz = RELz + dt*math.abs((z-RELz))
		elseif z < RELz then
			RELz = RELz - dt*math.abs((z-RELz))
		end
		if rotx > RELrotx then 
			RELrotx = RELrotx + dt*math.abs((rotx-RELrotx))
		elseif rotx < RELrotx then
			RELrotx = RELrotx - dt*math.abs((rotx-RELrotx))
		end
		if roty > RELroty then 
			RELroty = RELroty + dt*math.abs((roty-RELroty))
		elseif rotx < RELroty then
			RELroty = RELroty - dt*math.abs((roty-RELroty))
		end
		if rotz > RELrotz then 
			RELrotz = RELrotz + dt*math.abs((rotz-RELrotz))
		elseif rotz < RELrotx then
			RELrotz = RELrotz - dt*math.abs((rotz-RELrotz))
		end
	end

	if not bool then
		if RELx > 0 then 
			RELx = RELx - dt*math.abs((RELx-0))*3
		elseif RELx < 0 then
			RELx = RELx + dt*math.abs((RELx-0))*3
		end
		if RELy > 0 then 
			RELy = RELy - dt*math.abs((RELy-0))*3
		elseif RELy < 0 then
			RELy = RELy + dt*math.abs((RELy-0))*3
		end
		if RELz > 0 then 
			RELz = RELz - dt*math.abs((RELz-0))*3
		elseif RELz < 0 then
			RELz = RELz + dt*math.abs((RELz-0))*3
		end
		if RELrotx > 0 then 
			RELrotx = RELrotx - dt*math.abs((RELrotx-0))*3
		elseif RELrotx < 0 then
			RELrotx = RELrotx + dt*math.abs((RELrotx-0))*3
		end
		if RELroty > 0 then 
			RELroty = RELroty - dt*math.abs((RELroty-0))*3
		elseif RELroty < 0 then
			RELroty = RELroty + dt*math.abs((RELroty-0))*3
		end
		if RELrotz > 0 then 
			RELrotz = RELrotz - dt*math.abs((RELrotz-0))*3
		elseif RELrotz < 0 then
			RELrotz = RELrotz + dt*math.abs((RELrotz-0))*3
		end
	end

	local RELvec = Vec(RELx, RELy, RELz)

	local offset = Transform(Vec(0, 0, 0), QuatEuler(RELrotx, RELroty, RELrotz))
	offset.pos = VecAdd(offset.pos, RELvec)

	return offset
end

function SEL(bool, x, y, z, rotx, roty, rotz)
	local dt = GetTimeStep()*4

	if bool then
		if x > SELx then 
			SELx = SELx + dt*math.abs((x-SELx))
		elseif x < SELx then
			SELx = SELx - dt*math.abs((x-SELx))
		end
		if y > SELy then 
			SELy = SELy + dt*math.abs((y-SELy))
		elseif y < SELy then
			SELy = SELy - dt*math.abs((y-SELy))
		end
		if z > SELz then 
			SELz = SELz + dt*math.abs((z-SELz))
		elseif z < SELz then
			SELz = SELz - dt*math.abs((z-SELz))
		end
		if rotx > SELrotx then 
			SELrotx = SELrotx + dt*math.abs((rotx-SELrotx))
		elseif rotx < SELrotx then
			SELrotx = SELrotx - dt*math.abs((rotx-SELrotx))
		end
		if roty > SELroty then
			SELroty = SELroty + dt*math.abs((roty-SELroty))
		elseif rotx < SELroty then
			SELroty = SELroty - dt*math.abs((roty-SELroty))
		end
		if rotz > SELrotz then
			SELrotz = SELrotz + dt*math.abs((rotz-SELrotz))
		elseif rotz < SELrotz then
			SELrotz = SELrotz - dt*math.abs((rotz-SELrotz))
		end
	end

	if not bool then
		if SELx > 0 then 
			SELx = SELx - dt*math.abs((SELx-0))
		elseif SELx < 0 then
			SELx = SELx + dt*math.abs((SELx-0))
		end
		if SELy > 0 then 
			SELy = SELy - dt*math.abs((SELy-0))
		elseif SELy < 0 then
			SELy = SELy + dt*math.abs((SELy-0))
		end
		if SELz > 0 then 
			SELz = SELz - dt*math.abs((SELz-0))
		elseif SELz < 0 then
			SELz = SELz + dt*math.abs((SELz-0))
		end
		if SELrotx > 0 then 
			SELrotx = SELrotx - dt*math.abs((SELrotx-0))
		elseif SELrotx < 0 then
			SELrotx = SELrotx + dt*math.abs((SELrotx-0))
		end
		if SELroty > 0 then 
			SELroty = SELroty - dt*math.abs((SELroty-0))
		elseif SELroty < 0 then
			SELroty = SELroty + dt*math.abs((SELroty-0))
		end
		if SELrotz > 0 then 
			SELrotz = SELrotz - dt*math.abs((SELrotz-0))
		elseif SELrotz < 0 then
			SELrotz = SELrotz + dt*math.abs((SELrotz-0))
		end
	end

	local SELvec = Vec(SELx, SELy, SELz)

	local offset = Transform(Vec(0, 0, 0), QuatEuler(SELrotx, SELroty, SELrotz))
	offset.pos = VecAdd(offset.pos, SELvec)

	return offset
end

function INS(bool, x, y, z, rotx, roty, rotz)
	local dt = GetTimeStep()*4

	if bool then
		if x > INSx then 
			INSx = INSx + dt*math.abs((x-INSx))
		elseif x < INSx then
			INSx = INSx - dt*math.abs((x-INSx))
		end
		if y > INSy then 
			INSy = INSy + dt*math.abs((y-INSy))
		elseif y < INSy then
			INSy = INSy - dt*math.abs((y-INSy))
		end
		if z > INSz then 
			INSz = INSz + dt*math.abs((z-INSz))
		elseif z < INSz then
			INSz = INSz - dt*math.abs((z-INSz))
		end
		if rotx > INSrotx then 
			INSrotx = INSrotx + dt*math.abs((rotx-INSrotx))
		elseif rotx < INSrotx then
			INSrotx = INSrotx - dt*math.abs((rotx-INSrotx))
		end
		if roty > INSroty then 
			INSroty = INSroty + dt*math.abs((roty-INSroty))
		elseif rotx < INSroty then
			INSroty = INSroty - dt*math.abs((roty-INSroty))
		end
		if rotz > INSrotz then 
			INSrotz = INSrotz + dt*math.abs((rotz-INSrotz))
		elseif rotz < INSrotx then
			INSrotz = INSrotz - dt*math.abs((rotz-INSrotz))
		end
	end

	if not bool then
		if INSx > 0 then 
			INSx = INSx - dt*math.abs((INSx-0))
		elseif INSx < 0 then
			INSx = INSx + dt*math.abs((INSx-0))
		end
		if INSy > 0 then 
			INSy = INSy - dt*math.abs((INSy-0))
		elseif INSy < 0 then
			INSy = INSy + dt*math.abs((INSy-0))
		end
		if INSz > 0 then 
			INSz = INSz - dt*math.abs((INSz-0))
		elseif INSz < 0 then
			INSz = INSz + dt*math.abs((INSz-0))
		end
		if INSrotx > 0 then 
			INSrotx = INSrotx - dt*math.abs((INSrotx-0))
		elseif INSrotx < 0 then
			INSrotx = INSrotx + dt*math.abs((INSrotx-0))
		end
		if INSroty > 0 then 
			INSroty = INSroty - dt*math.abs((INSroty-0))
		elseif INSroty < 0 then
			INSroty = INSroty + dt*math.abs((INSroty-0))
		end
		if INSrotz > 0 then 
			INSrotz = INSrotz - dt*math.abs((INSrotz-0))
		elseif INSrotz < 0 then
			INSrotz = INSrotz + dt*math.abs((INSrotz-0))
		end
	end

	local INSvec = Vec(INSx, INSy, INSz)

	local offset = Transform(Vec(0, 0, 0), QuatEuler(INSrotx, INSroty, INSrotz))
	offset.pos = VecAdd(offset.pos, INSvec)

	return offset
end

function REC(bool, x, y, z, rotx, roty, rotz)
	local dt = GetTimeStep()*24

	if bool then
		if x > RECx then 
			RECx = RECx + dt*math.abs((x-RECx))
		elseif x < RECx then
			RECx = RECx - dt*math.abs((x-RECx))
		end
		if y > RECy then 
			RECy = RECy + dt*math.abs((y-RECy))
		elseif y < RECy then
			RECy = RECy - dt*math.abs((y-RECy))
		end
		if z > RECz then 
			RECz = RECz + dt*math.abs((z-RECz))
		elseif z < RECz then
			RECz = RECz - dt*math.abs((z-RECz))
		end
		if rotx > RECrotx then 
			RECrotx = RECrotx + dt*math.abs((rotx-RECrotx))
		elseif rotx < RECrotx then
			RECrotx = RECrotx - dt*math.abs((rotx-RECrotx))
		end
		if roty > RECroty then 
			RECroty = RECroty + dt*math.abs((roty-RECroty))
		elseif rotx < RECroty then
			RECroty = RECroty - dt*math.abs((roty-RECroty))
		end
		if rotz > RECrotz then 
			RECrotz = RECrotz + dt*math.abs((rotz-RECrotz))
		elseif rotz < RECrotx then
			RECrotz = RECrotz - dt*math.abs((rotz-RECrotz))
		end
	end

	if not bool then
		if RECx > 0 then 
			RECx = RECx - dt*math.abs((RECx-0))/16
		elseif RECx < 0 then
			RECx = RECx + dt*math.abs((RECx-0))/16
		end
		if RECy > 0 then 
			RECy = RECy - dt*math.abs((RECy-0))/16
		elseif RECy < 0 then
			RECy = RECy + dt*math.abs((RECy-0))/16
		end
		if RECz > 0 then 
			RECz = RECz - dt*math.abs((RECz-0))/16
		elseif RECz < 0 then
			RECz = RECz + dt*math.abs((RECz-0))/16
		end
		if RECrotx > 0 then 
			RECrotx = RECrotx - dt*math.abs((RECrotx-0))/16
		elseif RECrotx < 0 then
			RECrotx = RECrotx + dt*math.abs((RECrotx-0))/16
		end
		if RECroty > 0 then 
			RECroty = RECroty - dt*math.abs((RECroty-0))/16
		elseif RECroty < 0 then
			RECroty = RECroty + dt*math.abs((RECroty-0))/16
		end
		if RECrotz > 0 then 
			RECrotz = RECrotz - dt*math.abs((RECrotz-0))/16
		elseif RECrotz < 0 then
			RECrotz = RECrotz + dt*math.abs((RECrotz-0))/16
		end
	end

	local RECvec = Vec(RECx, RECy, RECz)

	local offset = Transform(Vec(0, 0, 0), QuatEuler(RECrotx, RECroty, RECrotz))
	offset.pos = VecAdd(offset.pos, RECvec)

	return offset
end

function CheckAmmo(magslot)
	local checkammo =  magtable2[magslot][2]
	local maxammo = magtable2[magslot][3]
	local percentage = checkammo/maxammo
	if percentage >= 1 then
		checkammotext = "Full"
	elseif percentage > 0.75 then
		checkammotext = "Nearly Full"
	elseif percentage > 0.5 then
		checkammotext = "Just Over Half Full"
	elseif percentage > 0.25 then
		checkammotext = "Just Under Half Full"
	elseif percentage > 0 then
		checkammotext = "Nearly Empty"
	else
		checkammotext = "Empty"
	end
	return checkammotext
end

function tick(dt)
	if GetString("game.player.tool") == "vector" and GetPlayerVehicle() == 0 then
		if realistic or GetBool("level.optionstriggered") then
			SetBool("hud.aimdot", false)
		end


		------CONTROLS------
		if InputDown("lmb") and not reloading and selectfire == 3 and not selectattachments and not selectmag and selectfireTimer == 0 and GetPlayerGrabShape() == 0 and not InputDown("shift") and inspectTimer <= 0 and magcheckTimer == 0 and not jammed and jamclearTimer == 0 then
			if grenadelauncherammo > 0 and grenadelauncher then
				ShootGrenade()
			elseif not grenadelauncher and ammo > 0 then
				Shoot()
			end
		elseif InputDown("lmb") and not reloading and selectfire == 2 and not selectattachments and not selectmag and selectfireTimer == 0 and GetPlayerGrabShape() == 0 and not InputDown("shift") and inspectTimer <= 0 and magcheckTimer == 0 and not jammed and jamclearTimer == 0 and burstshots < 2 then
			if grenadelauncherammo > 0 and grenadelauncher then
				ShootGrenade()
			elseif not grenadelauncher and ammo > 0 then
				Shoot()
			end
		elseif InputPressed("lmb") and not reloading and selectfire == 1 and not selectattachments and not selectmag and selectfireTimer == 0 and GetPlayerGrabShape() == 0 and not InputDown("shift") and inspectTimer <= 0 and magcheckTimer == 0 and not jammed and jamclearTimer == 0 then
			if grenadelauncherammo > 0 and grenadelauncher then
				ShootGrenade()
			elseif not grenadelauncher and ammo > 0 then
				Shoot()
				shootTimer = 0.11
			end
		end

		if InputPressed("lmb") and not reloading and not InputDown("shift") and inspectTimer <= 0 and magcheckTimer == 0 and jamclearTimer == 0 then
			spreadTimer = 1.25
			if (ammo == 0 or selectfire == 0 or jammed) and not selectattachments and not selectmag then
				PlaySound(dryfiresound, GetPlayerTransform().pos, 1, false)
			end
		end

		if InputReleased("lmb") and not reloading and selectfire > 0 then
			shootTimer = 0
			burstshots = 0
		end

		
		if InputDown("rmb") and selectfire > 0 and selectfireTimer == 0 and not selectattachments and not selectmag and GetPlayerGrabShape() == 0 and not InputDown("shift") and not selectmag and magcheckTimer == 0 and jamclearTimer == 0 then
			if InputPressed("rmb") then
				PlaySound(interactsound1, GetPlayerTransform().pos, 1)
			end
			ironsight = true
			inspectTimer = 0
		end
		if InputReleased("rmb") then
			ironsight = false
		end
		if selectfire == 0 and selectfireTimer <= 0 then
			ironsight = false
		end

		if InputPressed(leanrightKey) then
			e = not e
			q = false
		end

		if InputPressed(leanleftKey) then
			q = not q
			e = false
		end

		if InputPressed(meleeKey) and not reloading and not ironsight and shootTimer <= 0 and selectfire > 0 and stock ~= "removed" and not InputDown("shift") then
			meleeTimer = 0.8
			inspectTimer = 0
		end

		if InputPressed(selectfireKey) and not reloading and not selectattachments and not selectmag and not InputDown("shift") and magcheckTimer == 0 and jamclearTimer == 0 then
			SelectFire()
			inspectTimer = 0
			selecttextTimer = 3
		end
		if selecttextTimer > 0 then
			selecttextTimer = selecttextTimer - dt
		end
		if selecttextTimer < 0 then
			selecttextTimer = 0
		end

		if InputDown(attachmentsKey) and not reloading and selectfire > 0 and selectfireTimer <= 0 and not InputDown("shift") and magcheckTimer == 0 and jamclearTimer == 0 or GetBool("level.optionstriggered") then
			if InputPressed(attachmentsKey) and not GetBool("level.optionstriggered") then
				PlaySound(interactsound2, GetPlayerTransform().pos, 1)
				selectattachmentsTimer = 0.5
			end
			UiMakeInteractive()
			selectattachments = true
			ironsight = false
			inspectTimer = 0
		end
		if InputReleased(attachmentsKey) and not reloading and selectfire > 0 and selectfireTimer <= 0 and not InputDown("shift") then
			selectattachments = false
			selectattachmentsTimer = 0.25
		end

		if InputPressed(sideKey) and side ~= "" then
			sideattachment = not sideattachment
			PlaySound(uiselect, GetPlayerTransform().pos, 0.75)
		end
		Laser(sideattachment and side == "side1")
		Flashlight(sideattachment and side == "side2")
		Rangefinder(sideattachment and side == "side3")

		if InputPressed(magcheckKey) and not reloading and selectfire > 0 and selectfireTimer <= 0 and not InputDown("shift") and magcheckTimer == 0 and jamclearTimer == 0 then
			magcheckTimer = 4
			PlaySound(reloadsound, GetPlayerTransform().pos, 0.5)
			inspectTimer = 0
		end
		if magcheckTimer > 0 then
			magcheckTimer = magcheckTimer - dt*1.5
			ironsight = false
		end
		if magcheckTimer < 0 then
			magcheckTimer = 0
			PlaySound(reloadsound2, GetPlayerTransform().pos, 0.5)
		end

		if InputDown(reloadKey) and not reloading and selectfire > 0 and selectfireTimer <= 0 and not InputDown("shift") and magcheckTimer == 0 and not jammed and jamclearTimer == 0 then heldrTimer = heldrTimer + dt end
		if InputDown(reloadKey) and realistic and not reloading and selectfire > 0 and selectfireTimer <= 0 and not InputDown("shift") and magcheckTimer == 0 and not jammed and jamclearTimer == 0 and heldrTimer > 0.2 then
			UiMakeInteractive()
			selectmag = true
			ironsight = false
		else
			selectmag = false
		end
		if InputReleased(reloadKey) and heldrTimer <= 0.2 and realistic and not reloading and selectfire > 0 and selectfireTimer <= 0 and magcheckTimer == 0 and not jammed and jamclearTimer == 0 then
			for i = 1, totalmags do
				if magtable2[i][2] > magtable2[nextmagslot][2] and i ~= curmagslot then
					nextmagslot = i
				end
			end
			inspectTimer = 0
			Reload()
		end
		if InputReleased(reloadKey) then heldrTimer = 0 end

		if InputPressed(clearjamKey) and not reloading and selectfire > 0 and selectfireTimer <= 0 and not InputDown("shift") and magcheckTimer == 0 and jammed and jamclearTimer == 0 then
			jamclearTimer = 2
		end
		if jamclearTimer > 0 then
			jamclearTimer = jamclearTimer - dt
			ironsight = false
		end
		if jamclearTimer < 0 then
			jamclearTimer = 0
			jammed = false
			cocksoundplaying = false
		end

		if InputDown("shift") then
			ironsight = false
			selectattachments = false
			selectmag = false
			inspectTimer = 0
		end

		if grip == "grenade_launcher" then
			if InputPressed(grenadeKey) and not reloading then
				grenadelauncher = not grenadelauncher
			end
		else
			grenadelauncher = false
		end

		if InputPressed(inspectKey) and not reloading and not InputDown("shift") and selectfireTimer <= 0 and not ironsight and selectfire > 0 and not selectattachments and not selectmag and magcheckTimer == 0 and magcheckTimer == 0 and jamclearTimer == 0 then
			if inspectTimer <= 0 then
				inspectTimer = 6
				ironsight = false
			else
				inspectTimer = 0
			end
		end

		if selectfire == 3 then
			selectfireText = "Full"
		elseif selectfire == 2 then
			selectfireText = "Burst"
		elseif selectfire == 1 then
			selectfireText = "Semi"
		else
			selectfireText = "Safe"
		end

		if shootTimer <= 0 then
			if recoilAngle > 0 then
				recoilAngle = recoilAngle - 0.1*recoilAngle - 0.1
			elseif recoilAngle < 0 then
				recoilAngle = 0

			end
			if math.abs(rnd1) < 0.05 then
				rnd1 = 0
			elseif rnd1 > 0 then
				rnd1 = rnd1 - (rnd1+1)*0.025
			elseif rnd1 < 0 then
				rnd1 = rnd1 - (rnd1-1)*0.025
			end
			if math.abs(rnd2) < 0.05 then
				rnd2 = 0
			elseif rnd2 > 0 then
				rnd2 = rnd2 - (rnd2+1)*0.025
			elseif rnd2 < 0 then
				rnd2 = rnd2 - (rnd2-1)*0.025
			end
			if math.abs(rnd3) < 0.05 then
				rnd3 = 0
			elseif rnd3 > 0 then
				rnd3 = rnd3 - (rnd3+1)*0.025
			elseif rnd3 < 0 then
				rnd3 = rnd3 - (rnd3-1)*0.025
			end
			if math.abs(rnd4) < 0.05 then
				rnd4 = 0
			elseif rnd4 > 0 then
				rnd4 = rnd4 - (rnd4+1)*0.025
			elseif rnd4 < 0 then
				rnd4 = rnd4 - (rnd4-1)*0.025
			end
			if math.abs(rnd5) < 0.05 then
				rnd5 = 0
			elseif rnd5 > 0 then
				rnd5 = rnd5 - (rnd5+1)*0.025
			elseif rnd5 < 0 then
				rnd5 = rnd5 - (rnd5-1)*0.025
			end
			if math.abs(rnd6) < 0.05 then
				rnd6 = 0
			elseif rnd6 > 0 then
				rnd6 = rnd6 - (rnd6+1)*0.025
			elseif rnd6 < 0 then
				rnd6 = rnd6 - (rnd6-1)*0.025
			end
		end

		if ironsight then
			recoilFactor = recoilVertical*stockFactor
		else
			recoilFactor = recoilVertical*stockFactor*1.75
		end

		if ironsight then
			recoilMax = 12*muzzleFactor*gripfactory*barrelFactory*stockFactor
		else
			recoilMax = 24*muzzleFactor*gripfactory*barrelFactory*stockFactor
		end

		if toprail == "scope" and not (q or e) then
			spreadFactor = 1
		elseif toprail == "holo" and not (q or e) then
			spreadFactor = 1.75
		else
			spreadFactor = 2
		end

		toprail = GetString("savegame.mod.toprail")
		muzzle = GetString("savegame.mod.muzzle")
		stock = GetString("savegame.mod.stock")
		if realistic then
			if maginTimer > 0 then
				mag = magtable2[curmagslot][1]
			end
		else
			if maginTimer > 0 then
				mag = GetString("savegame.mod.mag")
			end
		end
		if GetBool("level.optionstriggered") then
			if realistic then
				mag = magtable[1] or ""
			else
				mag = GetString("savegame.mod.mag")
			end
		end
		grip = GetString("savegame.mod.grip")
		barrel = GetString("savegame.mod.barrel")
		side = GetString("savegame.mod.side")
		guard = GetString("savegame.mod.guard")

		for key, shell in ipairs(casing.shells) do
			if shell.active then
				Bouncing(shell)
				local rot = QuatEuler(90, shell[6], 0)
				local transform = Transform(shell.pos, rot)
				DrawSprite(spentcasing.sprite, transform, 0.4, 0.15, 0.35, 0.35, 0.35, 1, true, false)
			end
		end

		local b = GetToolBody()
		if b ~= 0 then
			local magoffset = Vec(0, 0, 0)
			local grenadeoffset = Vec(-0.025, 0.025, 0)
			local boltoffset = Vec(0, -0.025, 0)
			local selectoroffset = Vec(-0.025, 0.005, 0)
			local sightoffset = Vec(0, 0, -0.005)
			local suppressoroffset = Transform()
			local scopeoffset = Transform()
			local holooffset = Transform()
			local holooffset2 = Transform()
			local railoffset = Transform()
			local magtimer = magoutTimer + maginTimer
			offset = Transform(Vec(0, heightOffset, 0))
			local x, y, z, rot = 0.275, 0, 0, 0
			local adsFOV, adsTime = 0, 0
			local defaultTrans = Transform(Vec(0.25, 0.15, 0.25), QuatEuler(0, 0, 0))

			if grenadelauncher then
				x = 0
				y = 0.45
				z = 0
				rot = 0
			elseif q then
				x = 0.9
				y = 0
				z = 0
				rot = 30
			elseif e then
				x = -0.3
				y = 0.2
				z = 0
				rot = -15
			else
				if toprail == "holo" then
					x = 0.275
					y = 0.2625+sightadjust
					z = 0
					rot = 0
				elseif toprail == "" then
					x = 0.275
					y = 0.275+sightadjust
					z = 0
					rot = 0
				elseif toprail == "scope" then
					x = 0.275
					y = 0.25+sightadjust
					z = 0
					rot = 0
				elseif toprail == "sight3" then
					x = 0.275
					y = 0.2175+sightadjust
					z = 0
					rot = 0
				end
			end

			if reloading then
				adsFOV, adsTime = 0, 0.15
			elseif not (q or e or grenadelauncher) then
				if toprail == "" then
					adsFOV, adsTime = 10, 0.15
				elseif toprail == "scope" then
					adsFOV, adsTime = 80, 0.25
				elseif toprail == "holo" then
					adsFOV, adsTime = 20, 0.1
				elseif toprail == "sight3" then
					adsFOV, adsTime = 10, 0.075
				end
			elseif grenadelauncher then
				adsFOV, adsTime = 10, 0.15
			else
				adsFOV, adsTime = 0, 0.15
			end

			offset = ADS(ironsight, adsFOV, adsTime, -x, y, z, rot)

			if ironsight then
				btrans = GetBodyTransform(b)
				pvel = GetPlayerVelocity()
				if toprail == "holo" then
					holopoint = TransformToParentTransform(btrans, Transform(Vec(0.275-(rnd2+rnd5)/200, -0.2625+recoilAngle/400+(rnd1+rnd4)/200+recoilTimer/10, -1.05), QuatEuler(0, 180, 0)))
					holopoint.pos = VecAdd(holopoint.pos, VecScale(GetPlayerVelocity(), 0.02))
					reticle1 = LoadSprite("MOD/img/reticle1.png")
					DrawSprite(reticle1, holopoint, 0.025, 0.025, 1, 1, 1, 1, true)
				end
				if toprail == "sight3" then
					holopoint = TransformToParentTransform(btrans, Transform(Vec(0.275-(rnd2+rnd5)/200, -0.2125+recoilAngle/400+(rnd1+rnd4)/200+recoilTimer/10, -1.25), QuatEuler(0, 180, 0)))
					holopoint.pos = VecAdd(holopoint.pos, VecScale(GetPlayerVelocity(), 0.02))
					reticle4 = LoadSprite("MOD/img/reticle4.png")
					DrawSprite(reticle4, holopoint, 0.2, 0.15, 1, 1, 1, 1, true)
				end
				if toprail == "scope" then
					scopepoint = TransformToParentTransform(btrans, Transform(Vec(0.2745, -0.252, -1.05), QuatEuler(0, 180, 0)))
					reticle2 = LoadSprite("MOD/img/reticle2.png")
					DrawSprite(reticle2, scopepoint, 0.075, 0.075, 1, 1, 1, 1, true)
				end
			end

			local speed =VecLength(GetPlayerVelocity())
			sin1 = math.clamp(sin1 + cos1*dt*speed*2.8, -1.2, 1.2)
			cos1 = math.clamp(cos1 - sin1*dt*speed*2.8, -1.2, 1.2)
			sin2 = math.clamp(sin2 + cos2*dt*speed*0.7, -1.2, 1.2)
			cos2 = math.clamp(cos2 - sin2*dt*speed*0.7, -1.2, 1.2)
			swayy = sin1/10
			swayx = sin2/8
			offset.rot = QuatRotateQuat(offset.rot, QuatEuler(swayy*speed, swayx*speed, 0))
			if realistic then
				offset.rot = QuatRotateQuat(offset.rot, QuatEuler( math.sin(2.1*GetTime())/15*bipodFactor^4,  math.sin(1.3*GetTime())/10*bipodFactor^4, 0))
			end

			if meleeTimer > 0 then
				if meleeTimer > 0.6 then
					offset.rot = QuatEuler(0, (0.8-meleeTimer)*800, (0.8-meleeTimer)*50)
					offset.pos = VecAdd(offset.pos, Vec((0.8-meleeTimer)*1, (0.8-meleeTimer)*-1, (0.8-meleeTimer)*-7.5))
				elseif meleeTimer > 0.4 then
					offset.rot = QuatEuler(0, 160, 0)
					offset.pos = VecAdd(offset.pos, Vec(0.4+(meleeTimer-0.4)*1.5, 0, -2.5+(meleeTimer-0.4)*-1.5))
					stockPos = TransformToParentPoint(GetBodyTransform(GetToolBody()), Vec(0, -0.5, -0.65))
					if meleeTimer > 0.55 then
						if GetShapeMaterialAtPosition(shape, stockPos) == "glass" and math.random() > 0.8 then
							MakeHole(stockPos, 1)
						else
							MakeHole(stockPos, 0.3)
						end
					end
				else
					offset.rot = QuatEuler(0, meleeTimer*400, meleeTimer*100)
					offset.pos = VecAdd(offset.pos, Vec(0, 0, meleeTimer*-5))
				end

				meleeTimer = meleeTimer - dt
			end

			if selectfireTimer > 0 then
				selectfireTimer = selectfireTimer - dt
			end

			if inspectTimer > 0 then
				inspectTimer = inspectTimer - dt
			end

			if recoilTimer > 0 then
				offset.pos = VecAdd(offset.pos, Vec(0, 0, recoilTimer))
				offset.rot = QuatRotateQuat(offset.rot, QuatEuler((recoilTimer-0.02)*20, 0, 0))
				
				recoilTimer = recoilTimer - dt
				boltoffset = Vec(0, -0.025, recoilTimer*7)
			end
			local rx, ry, rz, rr1, rr2, rr3 = (rnd2+rnd5)/200, (recoilAngle/-150)-(rnd1+rnd4)/200-recoilTimer/10, recoilTimer/3, recoilAngle+(rnd1+rnd4)/4+(recoilTimer-0.02)*8, (rnd2+rnd5)/4, 0
			RECoffset = REC(recoilTimer>0, rx, ry, rz, rr1, rr2, rr3)
			offset.pos = VecAdd(offset.pos, RECoffset.pos)
			offset.rot = QuatRotateQuat(offset.rot, RECoffset.rot)

			if jammed and jamclearTimer < 1 and jamclearTimer > 0.7 then
				boltoffset = Vec(0, -0.025, 1-jamclearTimer)
				if not cocksoundplaying then
					cocksoundplaying = true
					PlaySound(cocksound2, GetPlayerTransform().pos, 0.5)
				end
			end

			if lightTimer > 0 then
				PointLight(toolPos, 1, 0.75, 0.25, (lightTimer/shotDelay)*lightFactor)
				lightTimer = lightTimer - dt
			end

			if magoutTimer < 0 then
				maginTimer = 0.6
				magoutTimer = 0
			end
			if maginTimer < 0 then
				maginTimer = 0
				if grenadelauncher then
					PlaySound(uiselect, GetPlayerTransform().pos, 1)
				else
					PlaySound(reloadsound2, GetPlayerTransform().pos, 0.5, false)
				end
			end
			if magoutTimer > 0 then
				if grenadelauncher then
					grenadeoffset = Vec(-0.025, -magoutTimer*3+0.025, -0.6)
				else
					magoffset = Vec(0, -(0.6-magoutTimer)*4, (0.6-magoutTimer))
				end
				magoutTimer = magoutTimer - dt/reloadFactor
			end
			if maginTimer > 0 then
				if grenadelauncher then
					grenadeoffset = Vec(-0.025, 0.025, -maginTimer)
				else
					magoffset = Vec(0, -maginTimer*4, maginTimer)
				end
				maginTimer = maginTimer - dt/reloadFactor
			end
			if magcheckTimer > 3.4 then
				magoffset = Vec(0, -(4-magcheckTimer)*2, (4-magcheckTimer)*0.5)
			elseif magcheckTimer > 2.8 then
				magoffset = Vec(-(3.4-magcheckTimer)*0.5, (3.4-magcheckTimer)*2-1.2, (3.4-magcheckTimer)*0.5+0.3)
			elseif magcheckTimer > 1.2 then
				magoffset = Vec(-0.3, 0, 0.6)
			elseif magcheckTimer > 0.6 then
				magoffset = Vec(-magcheckTimer*0.5+0.3, magcheckTimer*2-1.2-1.2, magcheckTimer*0.5+0.3-0.3)
			elseif magcheckTimer > 0 then
				magoffset = Vec(0, -magcheckTimer*2, magcheckTimer*0.5)
			end
			if not grenadelauncher or (grenadelauncherammo == 0 and not reloading) then
				grenadeoffset = Vec(0, 0, 1000)
			end

			local x1, y1, z1, rotx1, roty1, rotz1 = 0, 0, 0, 0, 0, 0
			if grenadelauncher then
					x1, y1, z1, rotx1, roty1, rotz1 = 0.1, -0.2, 0, 10, 5, -10
			elseif ironsight then
				if q then
					if ammo == 0 then
						if magoutTimer > 0 then
							x1, y1, z1, rotx1, roty1, rotz1 = 1.1, 0.25, 0, -5, 10, -50
						elseif maginTimer > 0 or reloadTimer > 0.8 then
							x1, y1, z1, rotx1, roty1, rotz1 = 1.2, 0.3, -0.1, -5, 10, -40
						elseif reloadTimer < 0.8 then
							x1, y1, z1, rotx1, roty1, rotz1 = 1.4, 0.4, -0.2, 10, 35, -60
						end
					else
						if magoutTimer > 0 or magcheckTimer > 0 then
							x1, y1, z1, rotx1, roty1, rotz1 = 0.1, 0.1, 0, -5, 10, -10
						elseif maginTimer > 0 or reloadTimer > 0.8 then
							x1, y1, z1, rotx1, roty1, rotz1 = 0, 0, 0, -5, 10, 0
						end
					end
				elseif e then
					if magoutTimer > 0 or magcheckTimer > 0 then
						x1, y1, z1, rotx1, roty1, rotz1 = 0, -0.05, 0, 10, -10, 10
					elseif maginTimer > 0 or (reloadTimer > 0.6 and ammo > 0) then
						x1, y1, z1, rotx1, roty1, rotz1 = 0, 0, 0, 5, -5, 0
					elseif reloadTimer < 0.8 and ammo == 0 then
						x1, y1, z1, rotx1, roty1, rotz1 = 0.35, -0.3, 0, 15, 25, -10
					end
				else
					if magoutTimer > 0 or magcheckTimer > 0 then
						x1, y1, z1, rotx1, roty1, rotz1 = 0.1, -0.05, 0, 0, 0, -20
					elseif maginTimer > 0 or (reloadTimer > 0.6 and ammo > 0) or (reloadTimer > 1 and ammo == 0) then
						x1, y1, z1, rotx1, roty1, rotz1 = 0.3, 0.1, 0, 0, 0, -35
					elseif reloadTimer < 0.8 and ammo == 0 then
						x1, y1, z1, rotx1, roty1, rotz1 = 0.3, 0.1, -0.1, -5, 10, 10
					end
				end
			else
				if magoutTimer > 0 or magcheckTimer > 0 then
					x1, y1, z1, rotx1, roty1, rotz1 = 0.1, 0.05, 0, 10, -10, -20
				elseif maginTimer > 0 or (reloadTimer > 0.6 and ammo > 0) then
					x1, y1, z1, rotx1, roty1, rotz1 = 0.1, 0, 0, 5, 0, -10
				elseif reloadTimer < 0.8 and ammo == 0 then
					x1, y1, z1, rotx1, roty1, rotz1 = 0.65, -0.2, 0, 10, 30, -25
				end
			end

			RELoffset = REL(reloading or magcheckTimer > 0, x1, y1, z1, rotx1, roty1, rotz1)
			offset.pos = VecAdd(offset.pos, RELoffset.pos)
			offset.rot = QuatRotateQuat(offset.rot, RELoffset.rot)

			if not GetBool("level.optionstriggered") then
			if selectattachmentsTimer > 0 and selectattachments then
				local t1 = (0.5 - selectattachmentsTimer)/0.5
				offset.pos = VecAdd(offset.pos, Vec(1*t1, 0, -0.8*t1*180/GetInt("options.gfx.fov")))
				offset.rot = QuatRotateQuat(offset.rot, QuatEuler(10*t1, 75*t1, -10*t1))
			elseif selectattachmentsTimer > 0 and not selectattachments then
				local t2 = selectattachmentsTimer/0.25
				offset.pos = VecAdd(offset.pos, Vec(1*t2, 0, -0.8*t2*180/GetInt("options.gfx.fov")))
				offset.rot = QuatRotateQuat(offset.rot, QuatEuler(10*t2, 75*t2, -10*t2))
			elseif selectattachments then
				offset.pos = VecAdd(offset.pos, Vec(1, 0, -0.8*180/GetInt("options.gfx.fov")))
				offset.rot = QuatRotateQuat(offset.rot, QuatEuler(10, 75, -10))
			end
			end
			if GetBool("level.optionstriggered") then
				offset.pos = VecAdd(offset.pos, Vec(optionsx+0.2+math.cos(math.pi*optionsrotx/180), 0.2, -1.5-math.sin(math.pi*optionsrotx/180)+optionszoom))
				offset.rot = QuatRotateQuat(offset.rot, QuatEuler(0, 100+optionsrotx, optionsroty))
				
				if InputValue("mousewheel") > 0 and optionszoom < 1 then
					optionszoom = optionszoom + 0.05
				elseif InputValue("mousewheel") < 0 and optionszoom > -2 then
					optionszoom = optionszoom - 0.05
				end
				if InputDown("rmb") and grabbed[1][1] == "" then
					optionsrotx = optionsrotx + InputValue("mousedx")/2
				end
				if InputDown("rmb") and grabbed[1][1] == "" then
					optionsroty = optionsroty + InputValue("mousedy")/20
				end
				if optionsroty > 0.1 then optionsroty = optionsroty - optionsroty*0.05 - 0.05 end
				if optionsroty < 0.1 then optionsroty = optionsroty - optionsroty*0.05 + 0.05 end
				if InputDown("lmb") and grabbed[1][1] == "" then
					optionsx = optionsx + InputValue("mousedx")/400
				end
			end

			if selectattachmentsTimer > 0 then
				selectattachmentsTimer = selectattachmentsTimer*0.9 - dt/20
			elseif selectattachmentsTimer < 0 then
				selectattachmentsTimer = 0
			end

			local x2, y2, z2, rotx2, roty2, rotz2 = 0, 0, 0, 0, 0, 0
			if inspectTimer > 4 then
				x2, y2, z2, rotx2, roty2, rotz2 = 1, 0, -0.75, 10, 75, -10
			elseif inspectTimer > 3 then
				x2, y2, z2, rotx2, roty2, rotz2 = 1, 0, -0.75, 10, 75, -20
			elseif inspectTimer > 1.25 then
				x2, y2, z2, rotx2, roty2, rotz2 = 0.25, -1, 0, 20, 30, 120
			elseif inspectTimer > 0 then
				x2, y2, z2, rotx2, roty2, rotz2 = 0.25, -0.25, 0.25, 20, 30, 0
			elseif jamclearTimer > 0 then
				x2, y2, z2, rotx2, roty2, rotz2 = 0.2, -0.1, 0.1, 10, 10, -10
			end

			INSoffset = INS(inspectTimer > 0 or jamclearTimer > 0, x2, y2, z2, rotx2, roty2, rotz2)
			offset.pos = VecAdd(offset.pos, INSoffset.pos)
			offset.rot = QuatRotateQuat(offset.rot, INSoffset.rot)

			local x3, y3, z3, rotx3, roty3, rotz3 = 0, 0, 0, 0, 0, 0
			if (selectfire == 0 or InputDown("shift")) and selectfireTimer <= 0 then
				x3, y3, z3, rotx3, roty3, rotz3 = 0.2, 0.2, -0.2, -20, 60, 0
			elseif ironsight and selectfireTimer > 0  then
				x3, y3, z3, rotx3, roty3, rotz3 = 0.15, 0, 0, 0, 5, -10
			elseif selectfireTimer > 0 then
				x3, y3, z3, rotx3, roty3, rotz3 = 0.4, 0, -0.25, 0, 5, -20
			else
				x3, y3, z3, rotx3, roty3, rotz3 = 0, 0, 0, 0, 0, 0
			end

			if not GetBool("level.optionstriggered") then SELoffset = SEL(selectfireTimer > 0 or selectfire == 0 or InputDown("shift"), x3, y3, z3, rotx3, roty3, rotz3)
			offset.pos = VecAdd(offset.pos, SELoffset.pos)
			offset.rot = QuatRotateQuat(offset.rot, SELoffset.rot) end

			if reloadTimer > 0.2 and reloading and ammo == 0 then
				boltoffset = Vec(0, -0.025, 0.2)
			elseif ammo == 0 and not reloading then
				boltoffset = Vec(0, -0.025, 0.2)
			end

			SetToolTransform(offset, 0.2)
			toolTrans = GetBodyTransform(b)
			toolPos = TransformToParentPoint(toolTrans, Vec(0.275, -0.6, -2.6))

			if body ~= b then
				body = b
				local shapes = GetBodyShapes(b)
				mag0 = shapes[2]
				bolt = shapes[3]
				bolt2 = shapes[30]
				bolt3 = shapes[41]
				selector = shapes[4]
				selector2 = shapes[38]
				suppressor = shapes[5]
				scope = shapes[6]
				holo = shapes[7]
				holo2 = shapes[8]
				reddot = shapes[39]
				reddot2 = shapes[40]
				rail = shapes[9]
				stock1 = shapes[10]
				muzzlebreak = shapes[11]
				muzzlebreak2 = shapes[12]
				mag1 = shapes[13]
				mag2 = shapes[14]
				mag3 = shapes[15]
				grip1 = shapes[16]
				grip1_2 = shapes[17]
				grip2 = shapes[18]
				grip3 = shapes[22]
				grip3_1 = shapes[23]
				grip3_2 = shapes[24]
				grip4 = shapes[25]
				barrel0 = shapes[19]
				barrel1 = shapes[20]
				barrel2 = shapes[21]
				side1 = shapes[26]
				side2 = shapes[27]
				side3 = shapes[28]
				grenade = shapes[29]
				guard0 = shapes[31]
				guard0_2 = shapes[32]
				guard1 = shapes[33]
				guard1_2 = shapes[34]
				guard2 = shapes[35]
				guard2_2 = shapes[36]
				magwell = shapes[37]
				magTrans = GetShapeLocalTransform(mag0)
				boltTrans = GetShapeLocalTransform(bolt)
				boltTrans2 = GetShapeLocalTransform(bolt2)
				boltTrans3 = GetShapeLocalTransform(bolt3)
				selectorTrans = GetShapeLocalTransform(selector)
				selectorTrans2 = GetShapeLocalTransform(selector2)
				suppressorTrans = GetShapeLocalTransform(suppressor)
				scopeTrans = GetShapeLocalTransform(scope)
				holoTrans = GetShapeLocalTransform(holo)
				holoTrans2 = GetShapeLocalTransform(holo2)
				reddotTrans = GetShapeLocalTransform(reddot)
				railTrans = GetShapeLocalTransform(rail)
				stock1Trans = GetShapeLocalTransform(stock1)
				muzzlebreakTrans = GetShapeLocalTransform(muzzlebreak)
				muzzlebreakTrans2 = GetShapeLocalTransform(muzzlebreak2)
				gripTrans = GetShapeLocalTransform(grip1)
				barrelTrans0 = GetShapeLocalTransform(barrel0)
				barrelTrans1 = GetShapeLocalTransform(barrel1)
				barrelTrans2 = GetShapeLocalTransform(barrel2)
				sideTrans1 = GetShapeLocalTransform(side1)
				sideTrans2 = GetShapeLocalTransform(side2)
				sideTrans3 = GetShapeLocalTransform(side3)
				grenadeTrans = GetShapeLocalTransform(grenade)
				guardTrans0 = GetShapeLocalTransform(guard0)
				magwellTrans = GetShapeLocalTransform(magwell)
			end

			mt = TransformCopy(magTrans)
			mt.pos = VecAdd(mt.pos, magoffset)
			mt.rot = QuatRotateQuat(mt.rot, QuatEuler(-15, 0, 0))

			bt = TransformCopy(boltTrans)
			bt.pos = VecAdd(bt.pos, boltoffset)
			bt2 = TransformCopy(boltTrans2)
			bt3 = TransformCopy(boltTrans3)

			st = TransformCopy(selectorTrans)
			st.pos = VecAdd(st.pos, selectoroffset)
			st2 = TransformCopy(selectorTrans2)
			st2.pos = VecAdd(st2.pos, selectoroffset)

			spt = TransformCopy(suppressorTrans)
			spt.pos = VecAdd(spt.pos, suppressoroffset)

			sct = TransformCopy(scopeTrans)

			ht = TransformCopy(holoTrans)
			ht2 = TransformCopy(holoTrans2)

			rdt = TransformCopy(reddotTrans)
			rdt2 = TransformCopy(reddotTrans)

			rt = TransformCopy(railTrans)
			rt.pos = VecAdd(rt.pos, railoffset)

			stt = TransformCopy(stock1Trans)
			stt.pos = VecAdd(stt.pos, stock1offset)

			mbt = TransformCopy(muzzlebreakTrans)
			mbt.pos = VecAdd(mbt.pos, muzzlebreakoffset)
			mbt2 = TransformCopy(muzzlebreakTrans2)
			mbt2.pos = VecAdd(mbt2.pos, muzzlebreakoffset2)

			gt1 = TransformCopy(gripTrans)
			gt1.pos = VecAdd(gt1.pos, gripoffset)
			gt1_2 = TransformCopy(gripTrans)
			gt1_2.pos = VecAdd(gt1_2.pos, gripoffset)

			gt2 = TransformCopy(gripTrans)
			gt2.pos = VecAdd(gt2.pos, gripoffset)

			gt3 = TransformCopy(gripTrans)
			gt3.pos = VecAdd(gt3.pos, gripoffset)
			gt3_1 = TransformCopy(gripTrans)
			gt3_1.pos = VecAdd(gt3_1.pos, gripoffset)
			gt3_2 = TransformCopy(gripTrans)
			gt3_2.pos = VecAdd(gt3_2.pos, gripoffset)

			glt = TransformCopy(gripTrans)
			glt.pos = VecAdd(glt.pos, gripoffset)

			brt0 = TransformCopy(barrelTrans0)
			brt0.pos = VecAdd(brt0.pos, barreloffset)

			brt1 = TransformCopy(barrelTrans1)
			brt1.pos = VecAdd(brt1.pos, barreloffset)

			brt2 = TransformCopy(barrelTrans2)
			brt2.pos = VecAdd(brt2.pos, barreloffset)

			sdt1 = TransformCopy(sideTrans1)
			sdt1.pos = VecAdd(sdt1.pos, sideoffset)
			sdt2 = TransformCopy(sideTrans2)
			sdt2.pos = VecAdd(sdt2.pos, sideoffset)
			sdt3 = TransformCopy(sideTrans3)
			sdt3.pos = VecAdd(sdt3.pos, sideoffset)

			grt = TransformCopy(grenadeTrans)
			grt.pos = VecAdd(grt.pos, grenadeoffset)

			gdt0 = TransformCopy(guardTrans0)
			gdt0.pos = VecAdd(gdt0.pos, guardoffset)
			gdt0_2 = TransformCopy(guardTrans0)
			gdt0_2.pos = VecAdd(gdt0.pos, guardoffset)
			gdt1 = TransformCopy(guardTrans0)
			gdt1.pos = VecAdd(gdt0.pos, guardoffset)
			gdt1_2 = TransformCopy(guardTrans0)
			gdt1_2.pos = VecAdd(gdt0.pos, guardoffset)
			gdt2 = TransformCopy(guardTrans0)
			gdt2.pos = VecAdd(gdt0.pos, guardoffset)
			gdt2_2 = TransformCopy(guardTrans0)
			gdt2_2.pos = VecAdd(gdt0.pos, guardoffset)

			mwt = TransformCopy(magwellTrans)
			mwt.pos = VecAdd(mwt.pos, magwelloffset)

			bt2.pos = VecAdd(bt2.pos, Vec(0.025, 0.025, 0))

			if reloadTimer < 0.3 and reloadTimer > 0.2 and reloading and ammo == 0 then
				bt2.rot = QuatRotateQuat(bt2.rot, QuatEuler(0, 0, -10*(0.3-reloadTimer)/0.1))
			elseif reloadTimer < 0.2 and reloadTimer > 0.1 and reloading and ammo == 0 then
				bt2.rot = QuatRotateQuat(bt2.rot, QuatEuler(0, 0, -10*(reloadTimer-0.1)/0.1))
			end

			if jamclearTimer < 1 and jamclearTimer > 0.7 then
				bt3.pos = VecAdd(bt3.pos, Vec(0.1*(1-jamclearTimer)/0.3, 0, 0.3*(1-jamclearTimer)/0.3))
				bt3.rot = QuatRotateQuat(bt3.rot, QuatEuler(0, 0, 90*(1-jamclearTimer)/0.3))
			end

			if selectfireTimer < 0.4 then
				if selectfire == 1 then
					st.rot = QuatRotateQuat(st.rot, QuatEuler(0, 0, 0))
					st.pos = VecAdd(st.pos, Vec(0, 0, 0))
				elseif selectfire == 2 then
					st.rot = QuatRotateQuat(st.rot, QuatEuler(40, 0, 0))
					st.pos = VecAdd(st.pos, Vec(0, -0.05, -0.025))
				elseif selectfire == 3 then
					st.rot = QuatRotateQuat(st.rot, QuatEuler(90, 0, 0))
					st.pos = VecAdd(st.pos, Vec(0, -0.05, -0.1))
				else
					st.rot = QuatRotateQuat(st.rot, QuatEuler(0, 0, 0))
					st.pos = VecAdd(st.pos, Vec(0, 0, 0))
				end
				if selectfire > 0 then
					st2.rot = QuatRotateQuat(st2.rot, QuatEuler(90, 0, 0))
					st2.pos = VecAdd(st2.pos, Vec(0, -0.05, -0.1))
				else
					st2.rot = QuatRotateQuat(st2.rot, QuatEuler(0, 0, 0))
					st2.pos = VecAdd(st2.pos, Vec(0, 0, 0))
				end
			elseif selectfireTimer > 0 then
				if selectfire0 == 1 then
					st.rot = QuatRotateQuat(st.rot, QuatEuler(0, 0, 0))
					st.pos = VecAdd(st.pos, Vec(0, 0, 0))
				elseif selectfire0 == 2 then
					st.rot = QuatRotateQuat(st.rot, QuatEuler(40, 0, 0))
					st.pos = VecAdd(st.pos, Vec(0, -0.05, -0.025))
				elseif selectfire0 == 3 then
					st.rot = QuatRotateQuat(st.rot, QuatEuler(90, 0, 0))
					st.pos = VecAdd(st.pos, Vec(0, -0.05, -0.1))
				else
					st.rot = QuatRotateQuat(st.rot, QuatEuler(0, 0, 0))
					st.pos = VecAdd(st.pos, Vec(0, 0, 0))
				end
				if selectfire > 0 then
					st2.rot = QuatRotateQuat(st2.rot, QuatEuler(90, 0, 0))
					st2.pos = VecAdd(st2.pos, Vec(0, -0.05, -0.1))
				else
					st2.rot = QuatRotateQuat(st2.rot, QuatEuler(0, 0, 0))
					st2.pos = VecAdd(st2.pos, Vec(0, 0, 0))
				end
			end

			muzzlelength = 0
			if muzzle == "muzzle1" then
				spt.pos = VecAdd(spt.pos, Vec(0.025, 0, -barrellength))
				lightFactor = 0.4
				muzzlelength = 0.8
			else
				spt.pos = Vec(0, 0, 1000)
				lightFactor = 2
				muzzleFactor = 1
			end
			if muzzle == "muzzle2" then
				mbt.pos = VecAdd(mbt.pos, Vec(0.075, -0.045, -barrellength))
				mbt2.pos = VecAdd(mbt2.pos, Vec(0, 0, -barrellength))
				mbt.rot = QuatEuler(-90, 0, 45)
				lightFactor = 3
				muzzleFactor = 0.75
				muzzlelength = 0.2
			else
				mbt.pos = Vec(0, 0, 1000)
				mbt2.pos = Vec(0, 0, 1000)
				mbt.rot = QuatEuler(0, 0, 0)
				lightFactor = 2
				muzzleFactor = 1
			end
			if toprail == "scope" then
				sct.pos = Vec(0.2, -0.425, -0.85)
			else
				sct.pos = Vec(0, 0, 1000)
			end
			if toprail == "holo" then
				ht.pos = Vec(0.175, -0.425, -1)
				ht2.pos = Vec(0.225, -0.35, -1)
			else
				ht.pos = Vec(0, 0, 1000)
				ht2.pos = Vec(0, 0, 1000)
			end
			if toprail == "sight3" then
				rdt.pos = Vec(0.175, -0.375, -0.95)
				rdt2.pos = Vec(0.2, -0.4, -1)
			else
				rdt.pos = Vec(0, 0, 1000)
				rdt2.pos = Vec(0, 0, 1000)
			end

			sct.pos = VecAdd(sct.pos, sightoffset)
			ht.pos = VecAdd(ht.pos, sightoffset)
			ht2.pos = VecAdd(ht2.pos, sightoffset)
			rdt.pos = VecAdd(rdt.pos, sightoffset)
			rdt2.pos = VecAdd(rdt2.pos, sightoffset)

			if stock == "removed" then
				stt.pos = Vec(0.5, -0.95, -1.15)
				stt.rot = QuatEuler(-90, -180, 0)
				stockFactor = 2
			else
				stt.pos = stt.pos
				stockFactor = 1
			end
			rt.pos = VecAdd(rt.pos, Vec(-0.025, 0.025, -0.005))
			mwt.pos = VecAdd(mwt.pos, Vec(0, 0.16, 0.135))
			mwt.rot = QuatRotateQuat(mwt.rot, QuatEuler(-15, 0, 0))

			if mag == "" or mag == "mag0" then
				magsize = 17
				reloadFactor = 0.9
				SetShapeLocalTransform(mag0, Transform(VecAdd(mt.pos, Vec(-0.025, 0.03, 0.15)), mt.rot))
				SetShapeLocalTransform(mag1, Transform(Vec(0, 0, 1000)))
				SetShapeLocalTransform(mag2, Transform(Vec(0, 0, 1000)))
				SetShapeLocalTransform(mag3, Transform(Vec(0, 0, 1000)))
			elseif mag == "mag1" then
				magsize = 33
				reloadFactor = 1.1
				SetShapeLocalTransform(mag1, Transform(VecAdd(mt.pos, Vec(-0.025, -0.375, 0.25)), mt.rot))
				SetShapeLocalTransform(mag0, Transform(Vec(0, 0, 1000)))
				SetShapeLocalTransform(mag2, Transform(Vec(0, 0, 1000)))
				SetShapeLocalTransform(mag3, Transform(Vec(0, 0, 1000)))
			elseif mag == "mag2" then
				magsize = 50
				reloadFactor = 1.3
				SetShapeLocalTransform(mag2, Transform(VecAdd(mt.pos, Vec(-0.175, -0.35, 0.3)), mt.rot))
				SetShapeLocalTransform(mag0, Transform(Vec(0, 0, 1000)))
				SetShapeLocalTransform(mag1, Transform(Vec(0, 0, 1000)))
				SetShapeLocalTransform(mag3, Transform(Vec(0, 0, 1000)))
			elseif mag == "mag3" then
				magsize = 100
				reloadFactor = 1.5
				SetShapeLocalTransform(mag3, Transform(VecAdd(mt.pos, Vec(-0.475, -0.35, 0.3)), mt.rot))
				SetShapeLocalTransform(mag0, Transform(Vec(0, 0, 1000)))
				SetShapeLocalTransform(mag1, Transform(Vec(0, 0, 1000)))
				SetShapeLocalTransform(mag2, Transform(Vec(0, 0, 1000)))
			end

			if grip == "grip1" then
				gripfactorx = 0.85
				gripfactory = 0.6
				gt1.pos = Vec(0.2, -0.85+guardheight, -1.6-guardlength)
				gt1_2.pos = Vec(0.225, -1.05+guardheight, -1.625-guardlength)
			else
				gt1.pos = Vec(0, 0, 1000)
				gt1_2.pos = Vec(0, 0, 1000)
			end
			if grip == "grip2" then
				gripfactorx = 0.6
				gripfactory = 0.85
				gt2.pos = Vec(0.225, -0.9+guardheight, -1.5-guardlength)
			else
				gt2.pos = Vec(0, 0, 1000)
			end
			if grip == "grip3" then
				local querypos = TransformToParentPoint(GetBodyTransform(GetToolBody()), Vec(0.25, -0.6, -2-barrellength*4/3))
				local hit, dist = QueryRaycast(querypos, Vec(0, -2, 0), 5, 0.2)
				local bipodded = (InputDown("ctrl") or dist < 0.4) and selectfire > 0
				if bipodded then
					gripfactorx = 0.4
					gripfactory = 0.4
					bipodFactor = 0.5
					gt3_1.pos = Vec(0.4, -1.35, -2.05-barrellength*4/3)
					gt3_2.pos = Vec(0.05, -1.325, -2.05-barrellength*4/3)
					gt3_1.rot = QuatEuler(0, 0, 10)
					gt3_2.rot = QuatEuler(0, 0, -10)
				else
					gripfactorx = 1
					gripfactory = 1
					bipodFactor = 1
					if barrel == "barrel2" then
						gt3_1.pos = Vec(0.3, -0.725, -1.3-barrellength)
						gt3_2.pos = Vec(0.15, -0.725, -1.3-barrellength)
					else
						gt3_1.pos = Vec(0.3, -0.675, -2.75-barrellength)
						gt3_2.pos = Vec(0.15, -0.675, -2.75-barrellength)
						gt3_1.rot = QuatEuler(90, 0, 0)
						gt3_2.rot = QuatEuler(90, 0, 0)
					end
					
				end
				gt3.pos = Vec(0.225, -0.725, -1.95-guardlength)
				
			else
				gt3.pos = Vec(0, 0, 1000)
				gt3_1.pos = Vec(0, 0, 1000)
				gt3_2.pos = Vec(0, 0, 1000)
			end
			if grip == "grenade_launcher" then
				gripfactorx = 1.1
				gripfactory = 1.1
				glt.pos = Vec(0.2, -0.9, -1.4)
			else
				glt.pos = Vec(0, 0, 1000)
			end
			if grip == "" then
				gripfactorx = 1
				gripfactory = 1
			end

			if barrel == "" then
				barrelFactorx = 1
				barrelFactory = 1
				barrelFactordamage = 1
				accuracyFactor = 1.2*bipodFactor
				barrellength = 0.05
				brt0.pos = brt0.pos
				if guard == "guard2" then
					SetString("savegame.mod.guard", "")
				end
			else
				brt0.pos = Vec(0, 0, 1000)
			end
			if barrel == "barrel1" then
				barrelFactorx = 1.1
				barrelFactory = 0.8
				barrelFactordamage = 1
				accuracyFactor = 1*bipodFactor
				barrellength = -0.25
				brt1.pos = brt1.pos
				if guard == "" or guard == "guard2" then
					SetString("savegame.mod.guard", "guard1")
				end
			else
				brt1.pos = Vec(0, 0, 1000)
			end
			if barrel == "barrel2" then
				barrelFactorx = 0.8
				barrelFactory = 1.1
				barrelFactordamage = 0.9
				accuracyFactor = 1*bipodFactor
				barrellength = 0.35
				brt2.pos = brt2.pos
			else
				brt2.pos = Vec(0, 0, 1000)
			end

			if side == "side1" then
				if guard == "guard2" then
					sdt1.pos = VecAdd(sdt1.pos, Vec(0, 0, -0.45))
				else
					sdt1.pos = sdt1.pos
				end
			else
				sdt1.pos = Vec(0, 0, 1000)
			end
			if side == "side2" then
				if guard == "guard2" then
					sdt2.pos = VecAdd(sdt2.pos, Vec(0.025, 0.025, -0.45))
				else
					sdt2.pos = VecAdd(sdt2.pos, Vec(0.025, 0.025, 0))
				end
			else
				sdt2.pos = Vec(0, 0, 1000)
			end
			if side == "side3" then
				sdt3.pos = sdt3.pos
			else
				sdt3.pos = Vec(0, 0, 1000)
			end

			if mag == "mag3" then
				SetString("savegame.mod.stock", "")
			end

			if guard == "" then
				gdt0.pos = Vec(0.175, -0.825, -1.35)
				gdt0_2.pos = Vec(0.2, -0.7, -1.35)
				guardlength = 0
				guardheight = -0.025
			else
				gdt0.pos = Vec(0, 0, 1000)
				gdt0_2.pos = Vec(0, 0, 1000)
			end
			if guard == "guard1" then
				gdt1.pos = Vec(0.225, -0.725, -1.35)
				gdt1_2.pos = Vec(0.2, -0.7, -1.35)
				guardlength = -0.1
				guardheight = 0
			else
				gdt1.pos = Vec(0, 0, 1000)
				gdt1_2.pos = Vec(0, 0, 1000)
			end
			if guard == "guard2" then
				gdt2.pos = Vec(0.175, -0.725, -1.5)
				gdt2_2.pos = Vec(0.2, -0.7, -1.35)
				guardlength = 0.3
				guardheight = 0
			else
				gdt2.pos = Vec(0, 0, 1000)
				gdt2_2.pos = Vec(0, 0, 1000)
			end

			SetShapeLocalTransform(bolt, bt)
			SetShapeLocalTransform(bolt2, bt2)
			SetShapeLocalTransform(bolt3, bt3)
			SetShapeLocalTransform(selector, st)
			SetShapeLocalTransform(selector2, st2)
			SetShapeLocalTransform(suppressor, spt)
			SetShapeLocalTransform(scope, sct)
			SetShapeLocalTransform(holo, ht)
			SetShapeLocalTransform(holo2, ht2)
			SetShapeLocalTransform(reddot, rdt)
			SetShapeLocalTransform(reddot2, rdt2)
			SetShapeLocalTransform(rail, rt)
			SetShapeLocalTransform(stock1, stt)
			SetShapeLocalTransform(muzzlebreak, mbt)
			SetShapeLocalTransform(muzzlebreak2, mbt2)
			SetShapeLocalTransform(grip1, gt1)
			SetShapeLocalTransform(grip1_2, gt1_2)
			SetShapeLocalTransform(grip2, gt2)
			SetShapeLocalTransform(grip3, gt3)
			SetShapeLocalTransform(grip3_1, gt3_1)
			SetShapeLocalTransform(grip3_2, gt3_2)
			SetShapeLocalTransform(grip4, glt)
			SetShapeLocalTransform(barrel0, brt0)
			SetShapeLocalTransform(barrel1, brt1)
			SetShapeLocalTransform(barrel2, brt2)
			SetShapeLocalTransform(side1, sdt1)
			SetShapeLocalTransform(side2, sdt2)
			SetShapeLocalTransform(side3, sdt3)
			SetShapeLocalTransform(grenade, grt)
			SetShapeLocalTransform(guard0, gdt0)
			SetShapeLocalTransform(guard0_2, gdt0_2)
			SetShapeLocalTransform(guard1, gdt1)
			SetShapeLocalTransform(guard1_2, gdt1_2)
			SetShapeLocalTransform(guard2, gdt2)
			SetShapeLocalTransform(guard2_2, gdt2_2)
			SetShapeLocalTransform(magwell, mwt)
		end

		if selectattachments then
			clickedmag = clickedmag1 or clickedmag2 or clickedmag3
			if clickedmag and selectattachments and not InputPressed(attachmentsKey) then
				Reload()
			end
		end
		if reloading and not clickedmag and selectattachments then
			selectattachments = false
			selectattachmentsTimer = 0.25
		end

		if not selectattachments then
			if (InputPressed(reloadKey) or clickedmag) and selectfireTimer == 0 then
				if not realistic and (ammo ~= magsize + 1 and not grenadelauncher) or (grenadelauncherammo == 0 and grenadelauncher) then
					Reload()
					inspectTimer = 0
				end
			end

			if (InputReleased(reloadKey) or clickedmag) and selectfireTimer == 0 then
				if realistic and curmagslot ~= nextmagslot then
					Reload()
					inspectTimer = 0
				end
			end
			
			if GetBool("ammobox.refill") then
				SetBool("ammobox.refill", false)
				mags = mags + 1
				PlaySound(refillsound, GetPlayerTransform().pos, 1, false)
			end

			if reloading then
				if reloadTimer > 0.4 then
					reloadTimer = reloadTimer - dt/reloadFactor
				elseif reloadTimer > 0 then
					reloadTimer = reloadTimer - dt
				end
				if reloadTimer < 0.4 and not cocksoundplaying and ammo == 0 then
					cocksoundplaying = true
					PlaySound(cocksound, GetPlayerTransform().pos, 0.45)
				end
				if reloadTimer < 0 then
					cocksoundplaying = false
					if grenadelauncher then
						grenadelauncherammo = 1
					else
						if realistic then
							if ammo == 0 then
								ammo = magtable2[curmagslot][2]
							else
								ammo = magtable2[curmagslot][2] + 1
							end
						else
							if ammo == 0 then
								ammo = magsize
							else
								ammo = magsize + 1
							end
						end
					end
					reloadTimer = 0
					reloading = false
				end
			end

			if selectfireTimer < 0.55 and selectfireTimer > 0 and not selectsoundplaying and selectfire ~= 1 then
				selectsoundplaying = true
				PlaySound(selectsound, GetPlayerTransform().pos, 0.85)
			end
			if selectfireTimer < 0 then
				selectsoundplaying = false
				selectfireTimer = 0
			end
			
		end

		btrans = GetBodyTransform(b)
		sightattachpoint = TransformToParentPoint(btrans, Vec(0.25, -0.15, -0.75))
		muzzleattachpoint = TransformToParentPoint(btrans, Vec(0.25, -0.35, -2.5-barrellength))
		stockattachpoint = TransformToParentPoint(btrans, Vec(0.25, -0.4, -0.6))
		sideattachpoint = TransformToParentPoint(btrans, Vec(0.1, -0.45, -1.65))
		magattachpoint = TransformToParentPoint(btrans, Vec(0.25, -0.65, -1))
		gripattachpoint = TransformToParentPoint(btrans, Vec(0.1, -0.85, -1.4-guardlength))
		barrelattachpoint = TransformToParentPoint(btrans, Vec(0.1, -0.65, -1.6))
		guardattachpoint = TransformToParentPoint(btrans, Vec(0.1, -0.25, -1.5))

		for key, shell in ipairs(ak47projectileHandler.shells) do
			if shell.active then
				ProjectileOperations(shell)
			end
		end
		for key, shell in ipairs(ak47grenadeHandler.shells) do
			if shell.active then
				GrenadeOperations(shell)
			end
		end
	
		if shootTimer > 0 or ammo == 0 then
			shootTimer = shootTimer - dt
		end
	end
end

function draw()
	if GetString("game.player.tool") == "vector" and GetPlayerVehicle() == 0 then
		if not realistic then
		if not unlimitedammo then
			UiPush()
				UiTranslate(UiCenter(), UiHeight()-60)
				UiAlign("center middle")
				UiColor(1, 1, 1)
				UiFont("bold.ttf", 32)
				UiTextOutline(0,0,0,1,0.1)
				if reloading then
					UiText("Reloading")
				elseif grenadelauncher then
					UiText(grenadelauncherammo.."/1 - Grenade")
				else
					UiText(ammo.."/"..magsize*math.max(0, mags-1).." - "..selectfireText)
				end
			UiPop()
		else
			UiPush()
				UiTranslate(UiCenter(), UiHeight()-60)
				UiAlign("center middle")
				UiColor(1, 1, 1)
				UiFont("bold.ttf", 32)
				UiTextOutline(0,0,0,1,0.1)
				if reloading then
					UiText("Reloading")
				elseif grenadelauncher then
					UiText(grenadelauncherammo.."/1 - Grenade")
				else
					UiText("Infinite")
				end
			UiPop()
		end
		end
		if realistic then
		if magcheckTimer > 0 and magcheckTimer < 2 then
			UiTranslate(UiCenter(), UiHeight()-60)
			UiAlign("center middle")
			UiAlign("center middle")
			UiColor(1, 1, 1, magcheckTimer)
			UiFont("bold.ttf", 32)
			local checkammo = CheckAmmo(curmagslot)
			UiText(checkammo)
		end
		if selecttextTimer > 0 then
			UiTranslate(UiCenter(), UiHeight()-60)
			UiAlign("center middle")
			UiAlign("center middle")
			UiColor(1, 1, 1, selecttextTimer)
			UiFont("bold.ttf", 32)
			UiText(selectfireText)
		end
		if jammed and jamclearTimer == 0 then
			UiTranslate(UiCenter(), UiHeight()-60)
			UiAlign("center middle")
			UiAlign("center middle")
			UiColor(1, 1, 1, 1)
			UiFont("bold.ttf", 32)
			UiText("Jammed")
		elseif jamclearTimer > 0 then
			UiTranslate(UiCenter(), UiHeight()-60)
			UiAlign("center middle")
			UiAlign("center middle")
			UiColor(1, 1, 1, jamclearTimer)
			UiFont("bold.ttf", 32)
			UiText("Jammed")
		end
		end
	end
	if GetString("game.player.tool") == "vector" and grenadelauncher and not selectattachments then
		UiPush()
			UiTranslate(UiCenter(), UiMiddle())
			UiAlign("center middle")
			UiImage("ui/hud/crosshair-launcher.png")
		UiPop()
	end
	if GetString("game.player.tool") == "vector" and sideattachment and side == "side3" then
		UiPush()
			local x,y,dist = UiWorldToPixel(sideattachpoint)
			UiTranslate(x, y)
			UiAlign("center middle")
			UiColor(1, 0.1, 0.1)
			UiFont("bold.ttf", 32)
			UiTextOutline(0,0,0,1,0.1)
			UiText(math.floor(range))
		UiPop()
	end

	if realistic and selectmag and GetString("game.player.tool") == "vector" then
		hoverindex=0
		UiPush()
			local x,y,dist=UiWorldToPixel(magattachpoint)
			if dist > 0 then
				UiTranslate(x-50,y+20)
				local curx,cury=UiGetRelativePos()
				UiPush()
					UiAlign("center middle")
					for i = 1, totalmags do
					clickedslot = MagButton(nextmagslot,i,true,{curx,cury},{"Ammo: ", CheckAmmo(i)},60,60)
					UiTranslate(60,0)
					curx,cury=curx+60,cury
					end
				UiPop()
			end
		UiPop()
	end


	------ATTACHMENTS MENU------
	if not realistic or GetBool("level.optionstriggered") then
	if selectattachments and GetString("game.player.tool") == "vector" and GetPlayerVehicle() == 0 then
	hoverindex=0
		UiPush()
			local x,y,dist=UiWorldToPixel(sightattachpoint)
			if dist > 0 then
				UiTranslate(x-50,y+20)
				local curx,cury=UiGetRelativePos()
				UiPush()
					UiAlign("center middle")
					clickedscope = AttachmentButton("toprail","scope",true,{curx,cury},{"Scope","3x magnification sight for medium range combat."})
					UiTranslate(-70,0)
					curx,cury=curx-70,cury
					clickedholo = AttachmentButton("toprail","holo",true,{curx,cury},{"Holographic Sight","1x magnification sight for close range combat."})
					UiTranslate(-70,0)
					curx,cury=curx-70,cury
					clickedholo = AttachmentButton("toprail","sight3",true,{curx,cury},{"Red Dot Sight","1x magnification with open and borderless sight picture."})
					UiTranslate(-70,0)
				UiPop()
			end
		UiPop()
		UiPush()
			local x,y,dist=UiWorldToPixel(muzzleattachpoint)
			if dist > 0 then
				UiTranslate(x-50,y+20)
				local curx,cury=UiGetRelativePos()
				UiPush()
					UiAlign("center middle")
					clickedmuzzle1 = AttachmentButton("muzzle","muzzle1",true,{curx,cury},{"Suppressor","Suppresses gun noise for sneaky combat."})
					UiTranslate(-70,0)
					curx,cury=curx-70,cury
					clickedmuzzle2 = AttachmentButton("muzzle","muzzle2",true,{curx,cury},{"Compensator","Reduces horizontal recoil, but turns your barrel into a flashbang."})
					UiTranslate(-70,0)
				UiPop()
			end
		UiPop()
		UiPush()
			local x,y,dist=UiWorldToPixel(sideattachpoint)
			if dist > 0 then
				UiTranslate(x-50,y+20)
				local curx,cury=UiGetRelativePos()
				UiPush()
					UiAlign("center middle")
					clickedside1 = AttachmentButton("side","side1",true,{curx,cury},{"Laser","A laser that points where you shoot."})
					UiTranslate(-70,0)
					curx,cury=curx-70,cury
					clickedside2 = AttachmentButton("side","side2",true,{curx,cury},{"Flashlight","Lights up the area in front of you."})
					UiTranslate(-70,0)
				UiPop()
			end
		UiPop()
		if not realistic then
		UiPush()
			local x,y,dist=UiWorldToPixel(magattachpoint)
			if dist > 0 then
				UiTranslate(x-50,y+20)
				local curx,cury=UiGetRelativePos()
				UiPush()
					UiAlign("center middle")
					clickedmag1 = AttachmentButton("mag","mag1",true,{curx,cury},{"40rnd Mag","Pew Pew Pew"})
					UiTranslate(-70,0)
					curx,cury=curx-70,cury
					clickedmag2 = AttachmentButton("mag","mag2",true,{curx,cury},{"50rnd Drum","Pew Pew Pew Pew Pew Pew"})
					UiTranslate(-70,0)
					curx,cury=curx-70,cury
					clickedmag3 = AttachmentButton("mag","mag3",true,{curx,cury},{"100rnd Double Drum","Pew Pew Pew Pew Pew Pew Pew Pew Pew Pew Pew Pew Pew Pew Pew Pew Pew Pew Pew Pew Pew Pew Pew Pew Pew Pew Pew Pew Pew Pew Pew Pew Pew Pew Pew Pew Pew Pew Pew Pew Pew Pew Pew Pew Pew Pew Pew Pew Pew Pew Pew Pew Pew Pew Pew Pew Pew Pew Pew Pew Pew Pew Pew"})
					UiTranslate(-70,0)
				UiPop()
			end
		UiPop()
		end
		UiPush()
			local x,y,dist=UiWorldToPixel(gripattachpoint)
			if dist > 0 then
				UiTranslate(x-50,y+20)
				local curx,cury=UiGetRelativePos()
				UiPush()
					UiAlign("center middle")
					clickedgrip1 = AttachmentButton("grip","grip1",true,{curx,cury},{"Vertical Grip","Decreased vertical recoil."})
					UiTranslate(-70,0)
					curx,cury=curx-70,cury
					clickedgrip2 = AttachmentButton("grip","grip2",true,{curx,cury},{"Angled Grip","Decreased horizontal recoil."})
					UiTranslate(-70,0)
				UiPop()
			end
		UiPop()
		UiPush()
			local x,y,dist=UiWorldToPixel(barrelattachpoint)
			if dist > 0 then
				UiTranslate(x-50,y+20)
				local curx,cury=UiGetRelativePos()
				UiPush()
					UiAlign("center middle")
					clickedbarrel1 = AttachmentButton("barrel","barrel1",true,{curx,cury},{"Short Barrel","Decreased accuracy but less vertical recoil."})
					UiTranslate(-100,0)
					curx,cury=curx-70,cury
					clickedbarrel2 = AttachmentButton("barrel","barrel2",true,{curx,cury},{"Extended Barrel","Increased accuracy and damage but more vertical recoil."})
					UiTranslate(-70,0)
				UiPop()
			end
		UiPop()
		UiPush()
			local x,y,dist=UiWorldToPixel(guardattachpoint)
			if dist > 0 then
				UiTranslate(x-50,y+20)
				local curx,cury=UiGetRelativePos()
				UiPush()
					UiAlign("center middle")
					clickedguard1 = AttachmentButton("guard","guard1",true,{curx,cury},{"Short Guard","For short barrels."})
					UiTranslate(-100,0)
					curx,cury=curx-70,cury
					if barrel == "barrel2" then
						clickedguard2 = AttachmentButton("guard","guard2",true,{curx,cury},{"Long Guard","For long barrels."})
					end
					UiTranslate(-70,0)
				UiPop()
			end
		UiPop()
	end
	end
	if selectattachments and GetString("game.player.tool") == "vector" and GetPlayerVehicle() == 0 or GetBool("level.optionstriggered") and GetString("game.player.tool") == "vector" then
	hoverindex=0
	UiPush()
		local x,y,dist=UiWorldToPixel(stockattachpoint)
			if dist > 0 then
				UiTranslate(x,y)
				local curx,cury=UiGetRelativePos()
				UiPush()
					UiAlign("center middle")
					clickedstockremoved = AttachmentButton("stock","removed",true,{curx,cury},{"Fold Stock","Folds stock for a smaller profile weapon."})
				UiPop()
			end
		UiPop()
	end
	if hint and (selectattachments or InputDown(reloadKey) and heldrTimer > 0.2) then drawHint(info) end


	------OPTIONS UI------
	if GetBool("level.optionstriggered") and GetString("game.player.tool") == "vector" then
	UiPush()
		UiAlign("center middle")
		UiTranslate(UiCenter(), 70)
		UiFont("bold.ttf", 60)
		UiText("WEAPON MODDING")
	UiPop()
	end
	
	if GetBool("level.optionstriggered") and GetString("game.player.tool") == "vector" then

	UiAlign("center middle")
	UiTranslate(300, 250)
	UiFont("bold.ttf", 48)
	UiText("VECTOR")
	UiFont("regular.ttf", 26)
	UiTranslate(0, 70)
	UiPush()
		UiText("Unlimited Ammo")
		UiTranslate(0, 40)
		UiAlign("center")
		UiColor(0.5, 0.8, 1)
		if realistic then
			UiText("Unvavailable")
		else
		if unlimitedammo then
			if UiTextButton("Yes", 20, 20) then
				unlimitedammo = false
				SetBool("savegame.mod.unlimitedammo", unlimitedammo)
			end
		else
			if UiTextButton("No", 20, 20) then
				unlimitedammo = true
				SetBool("savegame.mod.unlimitedammo", unlimitedammo)
			end
		end
		end
	UiPop()
	UiTranslate(0, 80)
	UiPush()
		UiText("Spent Casings")
		UiTranslate(15, 40)
		UiAlign("right")
		UiColor(0.5, 0.8, 1)
		if spentcasingsoption then
			if UiTextButton("Yes", 20, 20) then
				spentcasingsoption = false
				SetBool("savegame.mod.spentcasingsoption", spentcasingsoption)
			end
		else
			if UiTextButton("No", 20, 20) then
				spentcasingsoption = true
				SetBool("savegame.mod.spentcasingsoption", spentcasingsoption)
			end
		end
	UiPop()
	UiTranslate(0, 80)
	UiPush()
		UiText("Damage: "..damageoption.."%")
		UiTranslate(-50, 40)
		UiAlign("right")
		UiColor(0.5, 0.8, 1)
		damageoption = optionsSlider(damageoption, 50, 1000, 10)
		SetInt("savegame.mod.damage", damageoption)
	UiPop()

	UiTranslate(0, 70)
	UiPush()
		UiText("Realistic Mode")
		UiTranslate(0, 40)
		UiAlign("center")
		UiColor(0.5, 0.8, 1)
		if realistic then
			if UiTextButton("Yes", 20, 20) then
				realistic = false
				SetBool("savegame.mod.realistic", realistic)
			end
		else
			if UiTextButton("No", 20, 20) then
				realistic = true
				SetBool("savegame.mod.realistic", realistic)
				SetBool("savegame.mod.unlimitedammo", false)
			end
		end
	UiPop()

	UiTranslate(0, 100)
	hoverindex=0
	if realistic then
	magtable = {}

	UiPush()
		UiTranslate(-180, 150)
		MagButton2("mag0", 1, 2, "30rnd Mag")
		UiTranslate(60, 0)
		MagButton2("mag1", 1, 2, "40rnd Mag")
		UiTranslate(90, 0)
		MagButton2("mag2", 2, 2, "50rnd Drum")
		UiTranslate(150, 0)
		MagButton2("mag3", 3, 2, "100rnd Double Drum")
	UiPop()

	UiPush()
		UiAlign("center middle")
		UiTranslate(-30*(#slots-1), 20+30*(#slots[1]-1))
		for i = 1,#slots do
			for j = 1,#slots[i] do
				local w, h = slots[i][j][3], slots[i][j][4]
				UiTranslate(30*(w-1), 30*(h-1))
				local inside2 = UiIsMouseInRect(60*w-1, 60*h-1)
				UiTranslate(-30*(w-1), -30*(h-1))
				if inside2 then
					UiTranslate(30*(w-1), 30*(h-1))
					UiImageBox("ui/common/box-solid-6.png", 60*w, 60*h, 6, 6)
					UiTranslate(-30*(w-1), -30*(h-1))
				elseif slots[i][j][2][1] == i or slots[i][j][2][2] == j or slots[i][j][2][1] == 0 then
					UiTranslate(30*(w-1), 30*(h-1))
					UiColor(0.1, 0.2, 0.1)
					UiImageBox("ui/common/box-solid-6.png", 60*w, 60*h, 6, 6)
					UiColor(1, 1, 1)
					UiImageBox("ui/common/box-outline-6.png", 60*w, 60*h, 6, 6)
					UiTranslate(-30*(w-1), -30*(h-1))
				end
				UiTranslate(0, -60)
			end
			UiTranslate(60, 60*#slots[i])
		end
		UiTranslate(-60*#slots, 0)
		for i = 1,#slots do
			for j = 1,#slots[i] do
				local item, w, h = slots[i][j][1], slots[i][j][3], slots[i][j][4]
				UiTranslate(30*(w-1), 30*(h-1))
				if slots[i][j][1] ~= "" then
					UiImageBox("MOD/icon/"..item..".png", 60*w, 60*h, 0, 0)
					table.insert(magtable, item)
				end
				UiTranslate(-30*(w-1), -30*(h-1))
				if not InputDown("lmb") and UiIsMouseInRect(59, 59) and grabbed[1][1] ~= "" then
					placeItem(grabbed, i, j)
					grabbed = {{"", {0, 0}, 1, 1}, 0, 0}
				end
				if InputPressed("lmb") and UiIsMouseInRect(60, 60) then
					if slots[i][j][1] ~= "" then
						local w, h = slots[i][j][3], slots[i][j][4]
						grabbed = {slots[i][j], i, j}
						slots[i][j] = {"", {0, 0}, w, h}
					elseif slots[i][j][2][1] ~= 0 then
						local a = slots[i][j][2][1][1]
						local b = slots[i][j][2][1][2]
						local w, h = slots[a][b][3], slots[a][b][4]
						grabbed = {slots[a][b], a, b}
						slots[a][b] = {"", {0, 0}, w, h}
					end
				end
				UiTranslate(0, -60)
			end
			UiTranslate(60, 60*#slots[i])
		end
		if grabbed[1][1] ~= "" then
			local item, w, h = grabbed[1][1], grabbed[1][3], grabbed[1][4]
			local x, y = UiGetMousePos()
			UiTranslate(x+30*(w-1), y+30*(h-1))
			UiImageBox("MOD/icon/"..item..".png", 60*w, 60*h, 0, 0)
		end
		if not InputDown("lmb") and grabbed[1][1] ~= "" then
			clearItem(grabbed)
			grabbed = {{"", {0, 0}, 1, 1}, 0, 0}
		end
	UiPop()

	SetInt("savegame.mod.totalmags", #magtable)
	for i = 1, #magtable do
		SetString("savegame.mod.mslot"..i, magtable[i])
	end
	end

	if realistic then
		UiTranslate(0, 240)
	end
	if UiTextButton("Close", 80, 40) then
		Menu()
	end

	if not realistic then
		UiTranslate(0, 340)
	else
		UiTranslate(0, 100)
	end

	UiPush()
		UiTranslate(800+optionsx*100, -80)
		UiFont("bold.ttf", 26)
		UiTranslate(-120, 70)
		UiText("Horizontal Recoil: "..round(recoilHorizontal*stockFactor*laserFactor*muzzleFactor*gripfactorx*barrelFactorx, 2))
		UiTranslate(260, 0)
		UiText("Vertical Recoil: "..round(recoilFactor*muzzleFactor*gripfactory*barrelFactory, 2))
		UiTranslate(200, 0)
		UiText("Accuracy: "..round(1/accuracyFactor, 2))
	UiPop()

	UiPush()
		UiTranslate(-200, 50)
		UiPush()
			UiAlign("center middle")
			KeybindButton("Reload")
			UiTranslate(124, 0)
			KeybindButton("Check-Mag")
			UiTranslate(140, 0)
			KeybindButton("Fire-Mode")
			UiTranslate(132, 0)
			KeybindButton("Lean-Left")
			UiTranslate(132, 0)
			KeybindButton("Lean-Right")
			UiTranslate(152, 0)
			KeybindButton("Attachments")
			UiTranslate(132, 0)
			KeybindButton("Melee")
			UiTranslate(148, 0)
			KeybindButton("Side-Attachment")
			UiTranslate(204, 0)
			KeybindButton("Grenade-Launcher")
			UiTranslate(204, 0)
			KeybindButton("Inspect-Weapon")
			UiTranslate(164, 0)
			KeybindButton("Clear-Jam")
		UiPop()
	UiPop()
	end
end

function optionsSlider(current, min, max, incri)
    UiPush()
        UiTranslate(0, -8)
        local steps = incri or 1
        local value = (current - min) / (max - min)
        local width = 100
	UiTranslate(width, 0)
        UiRect(width, 3)
	UiTranslate(-width, 0)
        UiAlign("center middle")
        value = UiSlider("ui/common/dot.png", "x", value*width, 0, width)/width
        value = math.floor((value*(max-min)+min)/steps+0.5)*steps
    UiPop()
    return value
end

function round(number, decimals)
    local power = 10^decimals
    return math.floor(number * power) / power
end

function math.clamp(n, low, high) return math.min(math.max(n, low), high) end